unit hiStringTableMT; {     MT- ver MT_555CB}

interface

uses Windows,Messages,Share,Win,Debug,ListEdit,Kol;

const
   _Flags_NEV         = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER;
   _Flags_WL          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_WORDBREAK or DT_LEFT; 
   _Flags_WR          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_WORDBREAK or DT_RIGHT;
   _Flags_WC          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_WORDBREAK or DT_CENTER;
   _Flags_SL          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_SINGLELINE or DT_LEFT;
   _Flags_SR          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_SINGLELINE or DT_RIGHT;
   _Flags_SC          = DT_NOPREFIX or DT_END_ELLIPSIS or DT_VCENTER or DT_SINGLELINE or DT_CENTER;

   LOAD_TABLE         =  0 ;
   LOAD_ICON          =  2 ;
   LOAD_PAK_ICONS     =  4 ;
   LOAD_ILIST         =  5 ;
   LOAD_EXTICON       =  7 ;
   LOAD_STRING_LIST   =  10;
   LOAD_FSTREAM       =  13;

   SAVE_TABLE         =  1 ;
   SAVE_ICON_FILE     =  3 ;
   SAVE_ILIST         =  6 ;
   SAVE_STRING_LIST   =  8 ;
   APPEND_STRING_FILE =  9 ;
   SAVE_FSTREAM       =  14;

   SKIP               =  -1;

   ITM_ADD            =  -3;
   ITM_INSERT         =  -4;
   ITM_REPLACE        =  -5;

   EMATRIX            =  -6;
   CHK_EMATRIX        =  -7;
   SEL_EMATRIX        =  -8;

   COL_NAME           =  -9;
   COL_WIDTH          = -10;
   COL_IMAGE          = -11;
   COL_ALIGN          = -12;

   AColor: array [0..15] of TColor =
		   (clBlack, clMaroon, clGreen, clOlive, clNavy, clPurple, clTeal, clGray,
		   clSilver, clRed, clLime, clYellow, clBlue, clFuchsia, clAqua, clWhite);
   
type
  ThiStringTableMT = class(THIWin)
   private
    FStrFind, FStrReplace: String;
    FCol, FRow: Integer;

    FData,FData_1,FData_2: TData;
    ComboItem, ComboCol, ComboTopItem:integer;
    ComboBox:PControl;
    _FlagCombo:boolean;
    _FlagRedraw:boolean;
    indent:integer;
    SortCol:integer;
    Icon:PIcon;
    Obj:PMatrix;
    Arr,CBArray,SAArray,CLArray,ICArray,SLArray:PArray;
    IDList:PStrListEx;
    IList,IChList:PImageList;
    CList,FList:PStrList;
    _StrDlm:char;
    _ColorDlm:char;
    _MTColDlm:char;
    LoadStream, LICLStream, LTblStream:PStream;
    SICLStream, STblStream, FTblStream:PStream;

    FTextColor,FTextBkColor,FBkColor,FTransparent,FIconColColor: TColor;
    FAutoMakeVisible: boolean;
    FStyle: TListViewStyle;
    FTextAlign: TTextAlign;
    FSaveColProp,FSaveWidth,FSaveImgIndex,FSaveItemsColor,FSaveColor,FClearAll: boolean;
    FStaticColumn: boolean;
    FTableWBreak,FGrid3D,FBumpText,FExtIconsCheck,FColorItems,FAllMT_AddCol: boolean;
    FMethodSort,FModeMakeVisible,FStyleGrid3D,FColumnClick,FImgSize,FTypeComboInit: byte;
    FGrid,FHeaderDragDrop,FTrackSelect,FRowSelect,FCheckBoxes,FMultiSelect,FFlat: boolean;
    FMaxComboItem,FMaxColWidth,FMinColWidth,FColumnWidth:integer;
    FImgColumn,FIconToBmp,FFullSelect,FAppTxtStrLst,FAutoTblStrLst,FComboBox,FSelectFind :boolean;
    FAssignedIList,FRedaction,FAutoAddItem,FComboTextColor,FEnableOnClick,FFindReplace,FInfoTip: boolean;

    procedure StrDlm(Val:string);
    procedure ColorDlm(Val:string);
    procedure MTColDlm(Val:string);    
     
    procedure _onComboClick (Obj:PObj);
    procedure SetIListProp();
    procedure SetIcons(const value:PStrListEx);
    procedure SetIconsCheck(const value:PStrListEx);
    procedure SetMiscIcons(const value:PStrListEx);
    procedure SaveIListToFile(const FileName:string; Index:word);
    procedure LoadIListFromFile(const FileName:string; Index:word);
    procedure SetColumns(const ListCol:PStrList; Mode:integer);
    function _OnCmpText( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    function _OnCmpReal( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    function _OnCmpExt( Sender: PControl; Idx1, Idx2: Integer ): Integer;
    procedure _OnColumnClick( ender: PControl; Idx: Integer);
    procedure _OnBeforeLineChange(Sender: PControl; Idx: Integer);
    procedure _OnLineChange(Sender: PControl; Idx: Integer);
    function  _OnLVCustomDraw(Sender: PControl; DC: HDC; Stage: DWORD;
                  ItemIdx, SubItemIdx: Integer; const Rect: TRect;
                  ItemState: TDrawState; var TextColor, BackColor: TColor): DWORD;
    procedure Add(const Data:string; Index:integer = -1; _Replace:boolean = false);
    function _Count:integer;
    procedure MX_Set(x,y:integer; var Val:TData);
    function MX_Get(x,y:integer):TData;
    procedure CB_Set(var Item:TData; var Val:TData);
    function CB_Get(Var Item:TData; var Val:TData):boolean;
    procedure SA_Set(var Item:TData; var Val:TData);
    function SA_Get(Var Item:TData; var Val:TData):boolean;
    procedure _SetIcon(var Item:TData; var Val:TData);
    function _GetIcon(Var Item:TData; var Val:TData):boolean;
    procedure _AddIcon(var Val:TData);
    function  _CountIcon:integer;
    function InitColStr(var Val:string):string;
    procedure InsertIcon(Data:TData; Index:word);
    procedure _SetCol(var Item:TData; var Val:TData);
    function _GetCol(Var Item:TData; var Val:TData):boolean;
    procedure _AddCol(var Val:TData);
    function _CountCol:integer;
    procedure ClearIcons();
    procedure SetTextStrLst(const Value:string);
    procedure SetTextColLst(const Value:string);
    procedure _SetStrLst(var Item:TData; var Val:TData);
    function _GetStrLst(Var Item:TData; var Val:TData):boolean;
    function _CountStrLst:integer;
    procedure _AddStrLst(var Val:TData);
    function Get(index:integer):string;
    procedure _aSet(var Item:TData; var Val:TData);
    function _aGet(Var Item:TData; var Val:TData):boolean;
    procedure _aAdd(var Val:TData);
    function PakColor2Str(data:dword):string;
    procedure SetOption(OSet:boolean; Option:TListViewOption); 

    procedure _OnSelState( Sender: PControl; IdxFrom, IdxTo: Integer; OldState, NewState: cardinal );
    function LFileExists_MT(FileName:string;FileOperation:integer):boolean;
    function SFileExists_MT(FileName:string;FileOperation:integer):boolean;

    procedure MT_ActionItm(var Data:TData; Mode:integer);
    procedure MT_ActionCol(var Data:TData; Mode:integer);
    procedure MT_ProperCol(var Data:TData; Mode:integer);
    procedure MT_ActionIco(var Data:TData; Mode:integer);
    procedure MT_EMatrix(var Data:TData; Mode:integer);

   public

    _prop_FileName:string;
    _prop_IconFileName:string;
    _prop_IconsFileName:string;
    _prop_IListFileName:string;
    _prop_StrLstFName:string;
    
    _data_FileName:THI_Event;
    _data_IconFileName:THI_Event;
    _data_IconsFileName:THI_Event;
    _data_IListFileName:THI_Event;
    _data_EndEdit:THI_Event;
    _data_SFileExists_MT:THI_Event;
    _data_LFileExists_MT:THI_Event;
    _data_Str:THI_Event;
    _data_ExtCmp:THI_Event;
    _data_FTblStream:THI_Event;
    _data_StrLstFName:THI_Event;
    _data_StrLst:THI_Event;
    
    _event_onClick:THI_Event;
    _event_onColumnClick:THI_Event;
    _event_onChange:THI_Event;
    _event_onChangeImgLst:THI_Event;
    _event_onChangeColLst:THI_Event;
    _event_onGetIcon:THI_Event;
    _event_onGetMiscIcon:THI_Event; 
    _event_onGetIconIdx:THI_Event;
    _event_onMT_GetCol:THI_Event;
    _event_onMT_GetColors:THI_Event;
    _event_onMT_EMatrix:THI_Event;
    _event_onMT_Check:THI_Event;
    _event_onMT_FindText:THI_Event;
    _event_onExtIcon:THI_Event;
    _event_onChangeStrLst:THI_Event;
    _event_onGetStrList:THI_Event;
    _event_onBeforeLineChange:THI_Event;
    _event_onLineChange:THI_Event;
    _event_onComboClick:THI_Event;

    property _prop_InfoTip:boolean         write FInfoTip;
    property _prop_ReplaceFind:boolean     write FFindReplace;
    property _prop_EnableOnClick:boolean   write FEnableOnClick;
    property _prop_SelectFind:boolean      write FSelectFind;
    property _prop_AutoAddItem:boolean     write FAutoAddItem;
    property _prop_ComboTextColor:boolean  write FComboTextColor;
    property _prop_TypeComboInit:byte      write FTypeComboInit;
    property _prop_ColumnWidth:integer     write FColumnWidth;
    property _prop_MaxColWidth:integer     write FMaxColWidth;
    property _prop_MinColWidth:integer     write FMinColWidth;
    property _prop_Redaction:boolean       write FRedaction;
    property _prop_AssignedIList:boolean   write FAssignedIList;
    property _prop_ImgColumn:boolean       write FImgColumn;
    property _prop_IconToBmp:boolean       write FIconToBmp;
    property _prop_FullSelect:boolean      write FFullSelect;
    property _prop_AppTxtStrLst:boolean    write FAppTxtStrLst;
    property _prop_AutoTblStrLst:boolean   write FAutoTblStrLst;
    property _prop_ComboBox:boolean        write FComboBox;
    property _prop_ImgSize:byte            write FImgSize;  
    property _prop_ClearAll:boolean        write FClearAll;
    property _prop_ColumnClick:byte        write FColumnClick;
    property _prop_AllMT_AddCol:boolean    write FAllMT_AddCol;
    property _prop_ColorItems:boolean      write FColorItems;
    property _prop_ExtIconsCheck:boolean   write FExtIconsCheck;
    property _prop_MaxComboItem:integer    write FMaxComboItem;
    property _prop_AutoMakeVisible:boolean write FAutoMakeVisible;
    property _prop_StaticColumn:boolean    write FStaticColumn;
    property _prop_MethodSort:byte         write FMethodSort;
    property _prop_ModeMakeVisible:byte    write FModeMakeVisible;
    property _prop_StyleGrid3D:byte        write FStyleGrid3D;
    property _prop_TextAlign:TTextAlign    write FTextAlign;
    property _prop_Style:TListViewStyle    write FStyle;
    property _prop_TableWBreak:boolean     write FTableWBreak;
    property _prop_Grid3D:boolean          write FGrid3D;    
    property _prop_BumpText:boolean        write FBumpText;
    property _prop_SaveColProp:boolean     write FSaveColProp;
    property _prop_SaveWidth:boolean       write FSaveWidth;
    property _prop_SaveImgIndex:boolean    write FSaveImgIndex;
    property _prop_SaveItemsColor:boolean  write FSaveItemsColor;
    property _prop_SaveColor:boolean       write FSaveColor;
    property _prop_TranspColor:TColor      write FTransparent ;
    property _prop_Grid:boolean            write FGrid;
    property _prop_HeaderDragDrop:boolean  write FHeaderDragDrop;
    property _prop_TrackSelect:boolean     write FTrackSelect;
    property _prop_RowSelect:boolean       write FRowSelect;
    property _prop_CheckBoxes:boolean      write FCheckBoxes;
    property _prop_MultiSelect:boolean     write FMultiSelect;
    property _prop_TextColor:TColor        write FTextColor;
    property _prop_TextBkColor:TColor      write FTextBkColor;
    property _prop_BkColor:TColor          write FBkColor;
    property _prop_IconColColor:TColor     write FIconColColor;

    property _prop_StrDelimiter:string     write StrDlm;
    property _prop_ColorDelimiter:string   write ColorDlm;
    property _prop_MT_ColDelimiter:string  write MTColDlm;
    property _prop_Icons:PStrListEx        write SetIcons;
    property _prop_IconsCheck:PStrListEx   write SetIconsCheck;
    property _prop_MiscIcons:PStrListEx    write SetMiscIcons;
    property _prop_StringsStrLst:string    write SetTextStrLst;
    property _prop_Columns:string          write SetTextColLst;

    constructor Create(Parent:PControl);
    procedure Init; override;
    destructor Destroy; override;

    procedure _work_doAdd(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doSave(var _Data:TData; Index:word);
    procedure _work_doLoad(var _Data:TData; Index:word);
    procedure _work_doInsert(var _Data:TData; Index:word);
    procedure _work_doAddColumn(var _Data:TData; Index:word);
    procedure _work_doSort(var _Data:TData; Index:word);
    procedure _work_doSortDigit(var _Data:TData; Index:word);
    procedure _work_doSortExtCmp(var _Data:TData; Index:word);
    procedure _work_doSelect(var _Data:TData; Index:word);
    procedure _work_doEnsureVisible(var _Data:TData; Index:word);
    procedure _work_doInitTxtTab(var _Data:TData; Index:word);
    procedure _work_doReplace(var _Data:TData; Index:word);
    procedure _work_doLoadIcon(var _Data:TData; Index:word);
    procedure _work_doSaveIcon(var _Data:TData; Index:word);
    procedure _work_doSaveIList(var _Data:TData; Index:word);
    procedure _work_doLoadIList(var _Data:TData; Index:word);
    procedure _work_doLoadPakIcons(var _Data:TData; Index:word);
    procedure _work_doSaveFStream(var _Data:TData; Index:word);
    procedure _work_doLoadFStream(var _Data:TData; Index:word);
    procedure _work_doGetColors_MT(var _Data:TData; Index:word);
    procedure _work_doMT_Add(var _Data:TData; Index:word);
    procedure _work_doMT_AddCols(var _Data:TData; Index:word);
    procedure _work_doMT_Insert(var _Data:TData; Index:word);
    procedure _work_doMT_Replace(var _Data:TData; Index:word);    
    procedure _work_doMT_InsertCol(var _Data:TData; Index:word);
    procedure _work_doMT_ReplaceCol(var _Data:TData; Index:word);
    procedure _work_doMT_NameCol(var _Data:TData; Index:word);
    procedure _work_doMT_WidthCol(var _Data:TData; Index:word);
    procedure _work_doMT_ImageCol(var _Data:TData; Index:word);
    procedure _work_doMT_AlignTxtCol(var _Data:TData; Index:word);
    procedure _work_doMT_IconStr(var _Data:TData; Index:word);
    procedure _work_doMT_IconCol(var _Data:TData; Index:word);
    procedure _work_doMT_EMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_ChkEMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_SelEMatrix(var _Data:TData; Index:word);
    procedure _work_doMT_ColorsStr(var _Data:TData; Index:word);
    procedure _work_doMT_CheckBox(var _Data:TData; Index:word);
    procedure _work_doMT_ReplaceIcon(var _Data:TData; Index:word);
    procedure _work_doMT_InsertIcon(var _Data:TData; Index:word);
    procedure _work_doMT_LoadExtIcon(var _Data:TData; Index:word);
    procedure _work_doMT_FindText(var _Data:TData; Index:word);
    procedure _work_doMT_FindNext(var _Data:TData; Index:word);
    procedure _work_doClearCol(var _Data:TData; Index:word);
    procedure _work_doDeleteCol(var _Data:TData; Index:word);
    procedure _work_doGetCol_MT(var _Data:TData; Index:word);
    procedure _work_doCheckBoxes(var _Data:TData; Index:word);
    procedure _work_doTextColor(var _Data:TData; Index:word);
    procedure _work_doTextBkColor(var _Data:TData; Index:word);
    procedure _work_doBkColor(var _Data:TData; Index:word);
    procedure _work_doAutoMakeVisible(var _Data:TData; Index:word);
    procedure _work_doStyle(var _Data:TData; Index:word);
    procedure _work_doTextAlign(var _Data:TData; Index:word);
    procedure _work_doSaveColProp(var _Data:TData; Index:word);
    procedure _work_doSaveImgIndex(var _Data:TData; Index:word);
    procedure _work_doSaveItemsColor(var _Data:TData; Index:word);
    procedure _work_doSaveColor(var _Data:TData; Index:word);
    procedure _work_doSaveWidth(var _Data:TData; Index:word);
    procedure _work_doFlat(var _Data:TData; Index:word);
    procedure _work_doGrid(var _Data:TData; Index:word);
    procedure _work_doStaticColumn(var _Data:TData; Index:word);
    procedure _work_doHeaderDragDrop(var _Data:TData; Index:word);
    procedure _work_doInfoTip(var _Data:TData; Index:word);
    procedure _work_doTrackSelect(var _Data:TData; Index:word);
    procedure _work_doRowSelect(var _Data:TData; Index:word);
    procedure _work_doMultiSelect(var _Data:TData; Index:word);
    procedure _work_doGetIcon(var _Data:TData; Index:word);
    procedure _work_doGetIconIdx(var _Data:TData; Index:word);
    procedure _work_doDeleteIcon(var _Data:TData; Index:word);
    procedure _work_doTranspColor(var _Data:TData; Index:word);
    procedure _work_doClearIcons(var _Data:TData; Index:word);
    procedure _work_doMethodSort(var _Data:TData; Index:word);
    procedure _work_doSelEndStr(var _Data:TData; Index:word);
    procedure _work_doEndEdit(var _Data:TData; Index:word);
    procedure _work_doGetMiscIcon(var _Data:TData; Index:word);    
    procedure _work_doAddStrLst(var _Data:TData; Index:word);
    procedure _work_doClearStrLst(var _Data:TData; Index:word);
    procedure _work_doDeleteStrLst(var _Data:TData; Index:word);
    procedure _work_doLoadStrLst(var _Data:TData; Index:word);
    procedure _work_doSaveStrLst(var _Data:TData; Index:word);
    procedure _work_doAppendStrFile(var _Data:TData; Index:word);
    procedure _work_doInsertStrLst(var _Data:TData; Index:word);
    procedure _work_doTextStrLst(var _Data:TData; Index:word);
    procedure _work_doTblStrLst(var _Data:TData; Index:word);    
    procedure _work_doAddTextStrLst(var _Data:TData; Index:word);
    procedure _work_doSortStrLst(var _Data:TData; Index:word);
    procedure _work_doGetStrList(var _Data:TData; Index:word);
    procedure _work_doTableWBreak(var _Data:TData; Index:word);
    procedure _work_doGrid3D(var _Data:TData; Index:word);
    procedure _work_doBumpText(var _Data:TData; Index:word);
    procedure _work_doModeMakeVisible(var _Data:TData; Index:word);
    procedure _work_doStyleGrid3D(var _Data:TData; Index:word);
    procedure _work_doEnableCombo(var _Data:TData; Index:word);
    procedure _work_doComboColumn(var _Data:TData; Index:word);
    procedure _work_doComboInit(var _Data:TData; Index:word);
    procedure _work_doAutoColWidth(var _Data:TData; Index:word);
    procedure _work_doSelectFind(var _Data:TData; Index:word);
    procedure _work_doEnableOnClick(var _Data:TData; Index:word);
    procedure _work_doReplaceFind(var _Data:TData; Index:word);
    procedure _work_doRefresh(var _Data:TData; Index:word);

    procedure _var_GenColors_MT(var _Data:TData; Index:word);
    procedure _var_AllSelect_MT(var _Data:TData; Index:word);
    procedure _var_AllCheck_MT(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);
    procedure _var_EndIdx(var _Data:TData; Index:word);    
    procedure _var_Select(var _Data:TData; Index:word);
    procedure _var_Matrix(var _Data:TData; Index:word);
    procedure _var_Strings(var _Data:TData; Index:word);
    procedure _var_Index(var _Data:TData; Index:word);
    procedure _var_StringTable(var _Data:TData; Index:word);
    procedure _var_SelectArray(var _Data:TData; Index:word);
    procedure _var_ColumnArray(var _Data:TData; Index:word);
    procedure _var_IconArray(var _Data:TData; Index:word);
    procedure _var_CheckBoxes(var _Data:TData; Index:word);
    procedure _var_CountIcons(var _Data:TData; Index:word);
    procedure _var_EndIdxIcons(var _Data:TData; Index:word);    
    procedure _var_CountCol(var _Data:TData; Index:word);
    procedure _var_EndIdxCol(var _Data:TData; Index:word);    
    procedure _var_FullTextTab(var _Data:TData; Index:word);    
    procedure _var_FStream(var _Data:TData; Index:word);
    procedure _var_CountStrLst(var _Data:TData; Index:word);
    procedure _var_EndIdxStrLst(var _Data:TData; Index:word);    
    procedure _var_TextStrLst(var _Data:TData; Index:word);
    procedure _var_StrLstArray(var _Data:TData; Index:word);

  end;

function MakeArrayIcon(Names:PChar; Values:array of integer):PStrListEx;

implementation

function MakeArrayIcon;begin Result:= MakeArrayInteger(Names,Values);end;

constructor ThiStringTableMT.Create;
begin
   inherited Create(Parent);
   Icon:= NewIcon;
end;

destructor ThiStringTableMT.Destroy;
begin
   if Assigned(ComboBox)   then begin ComboBox.Text:=''; ComboBox.free; end;
   If Assigned(Icon)       then Icon.free;
   If Assigned(IList)      then IList.free;
   If Assigned(IChList)    then IChList.free;
   If Assigned(CList)      then CList.free;
   If Assigned(FList)      then FList.free;
   If Assigned(IDList)     then IDList.free;
   If Assigned(FTblStream) then FTblStream.free;
   if Obj <> nil           then Dispose(Obj);
   if CBArray <> nil       then Dispose(CBArray);
   if SAArray <> nil       then Dispose(SAArray);
   if CLArray <> nil       then Dispose(CLArray);
   if ICArray <> nil       then Dispose(ICArray);
   if SLArray <> nil       then Dispose(SLArray);
   FreeData(@FData);      
   FreeData(@FData_1);
   FreeData(@FData_2);
   inherited Destroy;
end;

procedure ThiStringTableMT._OnColumnClick;
begin
   case FColumnClick of
     0: _hi_OnEvent(_event_onColumnClick,Control.LVColText[Idx]);
     1: _hi_OnEvent(_event_onColumnClick,Idx);
   end;
end;

procedure ThiStringTableMT._OnBeforeLineChange;begin _hi_OnEvent(_event_onBeforeLineChange,Idx);end;
procedure ThiStringTableMT._OnLineChange;begin _hi_OnEvent(_event_onLineChange,Idx);end;

//---------------------       -----------------------

procedure ThiStringTableMT._OnSelState;
var   dt,Data:TData;
      s:string;
begin
   dtNull(Data);
   if _FlagCombo then Combobox.Visible:= False;
   if (Newstate = 3) or (Newstate = 1) then begin
      if _FlagCombo then begin;
         ComboItem:= IdxFrom;
         ComboTopItem:= Sender.LVTopItem;
         ComboBox.CurIndex:= 0;
         s:= Sender.LVItems[IdxFrom, ComboCol]; 
         if (FAutoAddItem) and (ComboBox.Count < FMaxComboItem) then begin
            if ComboBox.Insert(0,'') = -1 then ComboBox.Add('');
            ComboBox.CurIndex:= 0;
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
            if ComboBox.CurIndex > 0 then
               ComboBox.Delete(0)
            else begin
               ComboBox.Delete(0);
               ComboBox.Add(s);
            end;   
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
         end
         else
            ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
         _FlagRedraw:= True;
      end;
      if  FEnableOnClick then _hi_OnEvent(_event_onClick,IdxFrom);
      exit;
   end;
   if (Newstate = $2000) and (OldState =  $1000) then
      dtInteger(dt,1)
   else if (Newstate = $1000) and (OldState =  $2000) then
      dtInteger(dt,0)
   else exit;         
   dtInteger(Data,IdxFrom);
   Data.ldata:= @dt;
   _hi_onEvent_(_event_onMT_Check,Data);
end;

//---------------------       -----------------------

function ThiStringTableMT._OnLVCustomDraw;
var   Color,bkColor: TColor;
      idxColor: dword;
      str: string;
      ARect,BRect,CRect: TRect;
      _Flags: dword;
      SCT_cx, SCT_cy: integer;
      ColorText,ColorBack: TColor;
      l:TListViewOptions;
begin
TRY
   Result:= CDRF_DODEFAULT;
   if (Stage = CDDS_PREPAINT) then Result:= CDRF_NOTIFYITEMDRAW
   else if (Stage = CDDS_ITEMPREPAINT) then begin 
      if (Sender.LVItemData[ItemIdx] <> 0) and FColorItems then begin
         Color:= Sender.LVItemData[ItemIdx];
         bkColor:= $00FFFFFF and Color;
         if bkColor <> 0 then BackColor:= bkColor else BackColor:= Color2RGB(FTextBkColor);
         idxColor:= ($0F000000 and Color) shr 24;
         if idxColor <> 0 then TextColor:= AColor[idxColor] else TextColor:= Color2RGB(FTextColor);
      end else begin 
         BackColor:= Color2RGB(FTextBkColor);
         TextColor:= Color2RGB(FTextColor);
      end;            
      Result:=CDRF_NOTIFYSUBITEMDRAW
   end
   else if (Stage = CDDS_SUBITEM + CDDS_ITEMPREPAINT) and ((FStyle = lvsDetail) or (FStyle = lvsDetailNoHeader)) and FTableWBreak then begin
      l:= Control.LVOptions;
      str:= Sender.LVItems[ItemIdx,SubItemIdx];
      ARect:= Sender.LVSubItemRect(ItemIdx,SubItemIdx);
      if SubItemIdx = 0 then ARect.Right:= Arect.Left + Sender.LVColWidth[SubItemIdx];
      if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then
         ColorBack:= clHighlight
      else
         ColorBack:= BackColor;
      FillRect(DC,ARect,CreateSolidBrush(Color2RGB(ColorBack)));
      BRect:= ARect;
      SCT_cx := Sender.Canvas.TextExtent('M').cx; 
      SCT_cy := Sender.Canvas.TextExtent('W').cy; 
      ARect.Left:= ARect.Left + SCT_cx;
      ARect.Right:= ARect.Right - SCT_cx; 
      if (Sender.Canvas.TextExtent(Sender.LVItems[ItemIdx,SubItemIdx]).cx > ARect.Right - ARect.Left) then begin
         CRect:= ARect;
         ARect.Top:= ARect.Top + SCT_cy div 2;
         ARect.Bottom:= ARect.Bottom - SCT_cy div 2;
         if ARect.Bottom - ARect.Top < SCT_cy then ARect:= CRect;   
         case integer(Sender.LVColAlign[SubItemIdx]) of
            0: _Flags := _Flags_WL; 
            1: _Flags := _Flags_WR;
            2: _Flags := _Flags_WC
            else _Flags := _Flags_NEV; 
         end;
      end else   
         case integer(Sender.LVColAlign[SubItemIdx]) of
            0: _Flags := _Flags_SL;
            1: _Flags := _Flags_SR;
            2: _Flags := _Flags_SC
            else _Flags := _Flags_NEV;
         end;
      CRect:= ARect;
      inc(CRect.Left);
      inc(CRect.Top);
      inc(CRect.Right);
      inc(CRect.Bottom);
      if FBumpText then begin
         ColorText:= clHighlightText;
         if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then CRect:=ARect;    
         SetBkMode(DC,Color2RGB(ColorText));
         SetTextColor(DC,Color2RGB(ColorText));
         DrawText(DC,PChar(str),-1,CRect,_Flags);
      end;
      if (odsSelected in ItemState) and ((lvoRowSelect in l) or (not (lvoRowSelect in l)) and (SubItemIdx = 0)) then
         ColorText:= clHighlightText
      else
         ColorText:= TextColor;
      SetBkMode(DC,Color2RGB(ColorText));
      SetTextColor(DC,Color2RGB(ColorText));
      DrawText(DC,PChar(str),-1,ARect,_Flags);
      if (lvoGridLines in l) and FGrid3D then begin
         case FStyleGrid3D of
            0: DrawEdge(DC, BRect,EDGE_RAISED, BF_RECT);
            1: DrawEdge(DC, BRect,EDGE_SUNKEN, BF_RECT)
            else DrawEdge(DC, BRect,EDGE_RAISED, BF_RECT);
         end;
      end else if (lvoGridLines in l) then
         DrawEdge(DC, BRect,BDR_RAISEDINNER, BF_RECT or BF_FLAT);
      Result:= CDRF_SKIPDEFAULT;
   end;
FINALLY
   if (ComboTopItem - Sender.LVTopItem <> 0) and FComboBox then begin 
      _FlagRedraw:= False;
      ComboBox.Visible:= False;
   end;
   if _FlagRedraw and FComboBox then begin
      ARect:= Sender.LVSubItemRect(ComboItem, ComboCol);
      ComboBox.Width:= Sender.LVColWidth[ComboCol];
      if ComboBox.Height < FImgsize then 
         ARect.Top:= ARect.Top + round((FImgsize - ComboBox.Height)/2);
      ComboBox.Top:= ARect.Top;
      indent:= 0;
      if FCheckBoxes then indent:= FImgsize;
      if Assigned(IList) then indent:=  indent + FImgsize;
      if Assigned(IChList) or FCheckBoxes then indent:= indent + 2; 
      if (ComboCol = 0) and not FTableWBreak then begin
         ARect.Left:= ARect.Left + indent;
         ComboBox.Width:= ComboBox.Width - indent;
      end;
      ComboBox.Left:= ARect.Left;
      ComboBox.Visible:= True;   
      _FlagRedraw:= False;
   end;
END;
end;

function ThiStringTableMT.PakColor2Str;
var   hcl,lcl:string;
      idxcl:dword;
begin
   lcl:= int2str($FFFFFF and data);
   idxcl:= $0F000000 and data;
   hcl:= int2str(idxcl shr 24);
   Result:= hcl + _ColorDlm + lcl;
end;

procedure ThiStringTableMT.StrDlm;   begin if Val = '' then _StrDlm:= ' ' else _StrDlm:= Val[1];     end;
procedure ThiStringTableMT.ColorDlm; begin if Val = '' then _ColorDlm:= '#' else _ColorDlm:= Val[1]; end;
procedure ThiStringTableMT.MTColDlm; begin if Val = '' then _MTColDlm:= '_' else _MTColDlm:= Val[1]; end;

procedure ThiStringTableMT.Init;
var   l:TListViewOptions;
      ind:integer;
begin
   FFlat := _prop_Flat;
   if FMaxComboItem < 0 then FMaxComboItem:= MAXLONG;
   _FlagCombo:= FComboBox and not FRedaction;
   l:= [lvoUnderlineHot];
   if FInfoTip then include(l,lvoInfoTip);
   if FTrackSelect then include(l,lvoTrackSelect);
   if FHeaderDragDrop then include(l,lvoHeaderDragDrop);
   if FCheckBoxes then include(l,lvoCheckBoxes);
   if FMultiSelect then include(l,lvoMultiSelect);
   if FFlat then include(l,lvoFlatsb);
   if FGrid then include(l,lvoGridLines);
   if FRowSelect then include(l,lvoRowSelect);

   if not Assigned (IDList) then IDList:= NewStrListEx;

   if (not Assigned (IList)) and FAssignedIList then begin
      IList:= NewImageList(Control);
      if FImgsize = 0 then FImgsize:= GetSystemMetrics(SM_CXICON);
      SetIListProp;
   end;
   if FRedaction then
      if (Assigned (IChList)) and (FExtIconsCheck) then
           Control := NewListEdit(FParent,FStyle,l,IList,IList,IChList,_OnLineChange,_OnBeforeLineChange)
      else Control := NewListEdit(FParent,FStyle,l,IList,IList,nil,_OnLineChange,_OnBeforeLineChange)
   else
      if (Assigned (IChList)) and (FExtIconsCheck) then
           Control := NewListView(FParent,FStyle,l,IList,IList,IChList)
      else Control := NewListView(FParent,FStyle,l,IList,IList,nil);

   Control.OnColumnClick:=   _OnColumnClick;
   Control.OnLVCustomDraw:=  _OnLVCustomDraw;
   
   inherited;

   Control.LVTextColor:= FTextColor;
   Control.LVTextBkColor:= FTextBkColor;
   Control.LVBkColor:= FBkColor;
   Control.LVStyle:= FStyle;

   If _FlagCombo then begin
      ComboBox:= NewComboBox(Control,[coNoIntegralHeight,coReadOnly]);   
      ComboBox.Visible:= False;
      ComboBox.Color:= Control.Color;
      if FComboTextColor then ComboBox.Font.Color:= FTextColor;
      ComboBox.onSelChange:= _onComboClick;
   end;
   Control.OnLVStateChange:= _OnSelState;
   SetColumns(CList,0);
   if FAutoTblStrLst then for ind:= 0 to FList.Count - 1 do Add(FList.Items[ind]);
end;

procedure ThiStringTableMT._onComboClick;
begin
   if not _FlagCombo then Exit;
   Control.LVItems[ComboItem, ComboCol]:= ComboBox.Items[ComboBox.CurIndex]; 
   ComboBox.Visible:= False;
   _hi_OnEvent(_event_onComboClick,Control.LVItems[ComboItem, ComboCol]);
end;
procedure ThiStringTableMT.SetTextColLst;
begin
   CList:= NewStrList;
   Clist.Text:= Value;
end;

procedure ThiStringTableMT.SetColumns;
var   i:integer;
      s,str,sd:string;
begin
   if ListCol.Count = 0 then exit;
   i:= 0;
   Control.BeginUpdate;
   repeat
      s:= ListCol.Items[i] + '=';
      sd:= GetTok(s,'=');
      if sd <> '' then begin
         str:= sd;
         case Mode of
            0:  Control.LVColAdd(sd,FTextAlign,FColumnWidth);
            1:  Control.LVColText[i]:= sd;
         end;
         sd:= GetTok(s,'=');
         if sd = '' then
            sd:= int2str(FColumnWidth)
         else
            Control.LVColWidth[i]:= max(LVSCW_AUTOSIZE_USEHEADER,str2int(sd));
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if FImgColumn and Assigned(Ilist) and (IList.Count <> 0) then
            Control.LVColImage[i]:= str2int(sd);
         str:= str + '=' + sd;
         sd:= GetTok(s,'=');
         if sd <> '' then
            Control.LVColAlign[i]:= TTextAlign(str2int(sd))
         else begin
            Control.LVColAlign[i]:= FTextAlign;
            sd:= int2str(integer(Control.LVColAlign[i]));
         end;
         str:= str + '=' + sd;
         ListCol.Items[i]:= str;
      end;
      inc(i);
   until i = ListCol.Count; 
   Control.EndUpDate;
end;

//doAdd -    
//
procedure ThiStringTableMT._work_doAdd;
begin
   Add(ReadString(_Data,_data_Str,''));
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doInsert -   Str      
//
procedure ThiStringTableMT._work_doInsert;
begin
   Add(ToStringEvent(_data_Str),ToInteger(_Data),false);
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doReplace -         Str
//
procedure ThiStringTableMT._work_doReplace;
begin
   Add(ToStringEvent(_data_Str),ToInteger(_Data),true);
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//     
//
procedure ThiStringTableMT.Add;
var   s,ss:string;
      i,ico:integer;
      DColor:dword;       
begin
   s:= Data + _StrDlm;
   i:= 0;
   ico:= I_SKIP;
   DColor:= 0;
   if Index = -1 then begin
      Control.LVItemAdd('');
      Index:= Control.Count-1;
   end else if not _replace then Control.LVItemInsert(Index,'');
   if Assigned(Ilist) then ico:= Str2Int(gettok(s,_StrDlm));
   if FColorItems then begin
      ss:= gettok(s,_StrDlm) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
   end;
   repeat
      Control.LVSetItem(Index,i,gettok(s,_StrDlm),ico,[],I_SKIP,I_SKIP,DColor);
      inc(i);
   until s = '';
end;

//doInitTxtTab -          StrList
//
procedure ThiStringTableMT._work_doInitTxtTab;
var   List:PStrList;
      ind:integer;
begin
   List:= NewStrList;
   List.Text:= ReadString(_Data,_data_StrLst,'');
   for ind:= 0 to List.Count - 1 do Add(List.Items[ind]);
   List.free;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doRefresh -   
//
procedure ThiStringTableMT._work_doRefresh;
begin
   Control.Invalidate;
end;

procedure ThiStringTableMT._work_doClear;
begin
   Control.BeginUpdate;
   Control.Clear;
   if FClearAll then begin
      repeat
         Control.LVColDelete(Control.LVColCount-1);
      until Control.LVColCount <= 0;
      CList.Clear;
   end;
   Control.EndUpdate;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doSelect -       
//
procedure ThiStringTableMT._work_doSelect;
var   ind,begitm:integer;
begin
   ind:= ToInteger(_Data);
   Control.LVCurItem:= ind; 
   If not FAutoMakeVisible then Exit;
   if (FStyle = lvsDetail) or (FStyle = lvsDetailNoHeader) then
      case FModeMakeVisible of
         1: begin
               begitm:= ind + Control.LVPerPage;
               if begitm > Control.Count - 1 then begitm:= Control.Count - 1; 
               ind:= begitm - Control.LVPerPage; 
               Control.LVMakeVisible(begitm,false);
            end;
         2: begin 
               begitm:= ind + Control.LVPerPage div 2;
               if begitm > Control.Count - 1 then begitm:= Control.Count - 1; 
               ind:= begitm - Control.LVPerPage; 
               if ind < 0 then ind:= 0;
               Control.LVMakeVisible(begitm,false);
            end;
         3: begin
               begitm:= ind - Control.LVPerPage;
               if begitm < 0 then begitm:= 0;
               Control.LVMakeVisible(begitm,false);
            end;
      end; 
   Control.LVMakeVisible(ind,false);
end;

//doEnsureVisible -       
//
procedure ThiStringTableMT._work_doEnsureVisible;
begin
   If FAutoMakeVisible then exit;
   Control.LVMakeVisible(ToInteger(_Data), False);
end;

//doDelete -        
//
procedure ThiStringTableMT._work_doDelete;
begin
   Control.LVDelete(ToInteger(_Data));
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//  doSort;
//
function ThiStringTableMT._OnCmpText;
var   S1,S2:string;
begin
   S1 := Sender.LVItems[ Idx1, SortCol ];
   S2 := Sender.LVItems[ Idx2, SortCol ];
   if FMethodSort = 1 then
      Result := AnsiCompareStrNoCase( S2, S1 )
   else
      Result := AnsiCompareStrNoCase( S1, S2 );
end;

//  doSortDigit;
//
function ThiStringTableMT._OnCmpReal;
var   S1,S2:string; r:real;
begin
   S1 := Sender.LVItems[ Idx1, SortCol ];
   S2 := Sender.LVItems[ Idx2, SortCol ];
   r := str2double(S1)-str2double(S2);
   if FMethodSort = 1 then
      Result := ord(r<0)-ord(r>0)
   else
      Result := ord(r>0)-ord(r<0);
end;

//  doSortExtCmp;
//
function ThiStringTableMT._OnCmpExt;
var dt1,dt2:TData; r:real;
begin
   dtString(dt1, Sender.LVItems[ Idx1, SortCol ]);
   dtString(dt2, Sender.LVItems[ Idx2, SortCol ]);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_ExtCmp);
   r := ToReal(dt1);
   if FMethodSort = 1 then
      Result := ord(r<0)-ord(r>0)
   else
      Result := ord(r>0)-ord(r<0);
end;

//doSort -      ,   MethodSort
//
procedure ThiStringTableMT._work_doSort;
begin
   Control.OnCompareLVItems := _OnCmpText;
   SortCol := ToInteger(_Data);
   Control.LVSort;
  if _FlagCombo then ComboBox.Visible:= False;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doSortDigit -      ,  ,   MethodSort
//
procedure ThiStringTableMT._work_doSortDigit;
begin
   Control.OnCompareLVItems := _OnCmpReal;
   SortCol := ToInteger(_Data);
   Control.LVSort;
   if _FlagCombo then ComboBox.Visible:= False;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doSortExtCmp -      ,      ExtCmp: >0, =0,  <0,   MethodSort
//
procedure ThiStringTableMT._work_doSortExtCmp;
begin
   Control.LVMakeVisible(Control.LVCurItem,false);
   Control.OnCompareLVItems := _OnCmpExt;
   SortCol := ToInteger(_Data);
   Control.LVSort;
   if _FlagCombo then ComboBox.Visible:= False;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doSelEndStr -        AutoMakeVisible=True
//
procedure ThiStringTableMT._work_doSelEndStr;
begin
   If not FAutoMakeVisible Then Exit;
   Control.LVCurItem:= Control.Count - 1;
   Control.LVMakeVisible(Control.Count - 1,True);
end;

function ThiStringTableMT.Get;
var   i:integer;
      s:string;
begin
   Result := '';
   if Control.LVColCount > 0 then
      begin
         s:= '';
         if (Assigned(Ilist)) and FFullSelect then
            s:= int2str(Control.LVItemImageIndex[Index]) + _StrDlm;
         if FColorItems and FFullSelect  then
            s:= s + PakColor2Str(Control.LVItemData[Index]) + _StrDlm;;
         for i:= 0 to Control.LVColCount - 1 do
            begin
               s:= s + Control.LVItems[Index,i];
               if i < Control.LVColCount - 1 then
                  s:= s + _StrDlm;
            end;
         Result:= s;   
      end;
end;

procedure ThiStringTableMT._aSet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
      Add(ToString(val),ind, true);
end;

procedure ThiStringTableMT._aAdd;
begin
   Add(ToString(val), -1);
end;

function ThiStringTableMT._aGet;
var ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < Control.Count)then
     begin
        Result := true;
        dtString(Val,Get(ind));
     end
   else Result := false;
end;

//_Count -  
//
function ThiStringTableMT._Count;
begin
   Result := Control.Count;
end;

//Strings -   ,      ,  StrDelimiter'
//
procedure ThiStringTableMT._var_Strings;
begin
  if arr = nil then
     arr := CreateArray(_aset,_aget,_Count,_aadd);
  dtArray(_Data,Arr);
end;

//Count -     
//
procedure ThiStringTableMT._var_Count;
begin
   dtInteger(_Data,Control.Count);
end;

//EndIdx -      
//
procedure ThiStringTableMT._var_EndIdx;
begin
   if Control.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,Control.Count - 1);
end;

//Select -     ,   StrDelimiter
//
procedure ThiStringTableMT._var_Select;
begin
   if Control.LVCurItem = -1 then
      dtString(_Data,'')
   else
      dtString(_Data,Get(Control.LVCurItem));
end;

//FullTextTab -        
//                     10  13
//
procedure ThiStringTableMT._var_FullTextTab;
var   i,j:integer;
      s:string;
begin
   if (Control.Count = 0) or (Control.LVColCount = 0) then Exit;
   s:= '';
   j:= 0;
   repeat
      if Assigned(Ilist) then s:= s + int2str(Control.LVItemImageIndex[j]) + _StrDlm;
      if FColorItems then s:= s + PakColor2Str(Control.LVItemData[j]) + _StrDlm;
      i:= 0;
      repeat
         s:= s + Control.LVItems[j,i];
         if i < Control.LVColCount - 1 then s:= s + _StrDlm;
         inc(i);
      until i > Control.LVColCount - 1; 
      s:= s + #13#10;
      inc(j);
   until j > Control.Count - 1;
   dtString(_Data,s);
end;

//Index -    
//
procedure ThiStringTableMT._var_Index;
begin
   dtInteger(_Data,Control.CurIndex);
end;

//StringTable -    
//
procedure ThiStringTableMT._var_StringTable;
begin
   _Data.Data_type := data_int;
   _Data.sdata := 'StringTableMT';
   _Data.idata := integer(Control);
end;

//SelectArray -   
//
procedure ThiStringTableMT._var_SelectArray;
begin
   if not Assigned(SAArray) then
      SAArray := CreateArray(SA_Set,SA_Get,_Count,nil);
   dtArray(_Data,SAArray);
end;

procedure ThiStringTableMT.SA_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count)and(ToInteger(Val) = 1) then
   Control.LVItemState[ind]:= [lvisSelect];
end;

function ThiStringTableMT.SA_Get(Var Item:TData; var Val:TData):boolean;
var  ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if (ind >= 0)and(ind < Control.Count) then
      if lvisSelect in Control.LVItemState[ind] then dtInteger(Val,1) else dtInteger(Val,0)
   else Result:= False;
end;

//CheckBoxes -    (0 -  , 1 - )
//
procedure ThiStringTableMT._var_CheckBoxes;
begin
   if not Assigned(CBArray) then
      CBArray := CreateArray(CB_Set,CB_Get,_Count,nil);
   dtArray(_Data,CBArray);
end;

procedure ThiStringTableMT.CB_Set(var Item:TData; var Val:TData);
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      Control.LVItemStateImgIdx[ind]:= toInteger(Val) + 1;
end;

function ThiStringTableMT.CB_Get(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < Control.Count) then
      begin
         dtInteger(Val,Control.LVItemStateImgIdx[ind] - 1);
         Result:= True;
      end
   else Result:= False;
end;

//#####################################################################
//#                                                                   #
//#                                                   #
//#                                                                   #
//#####################################################################

procedure ThiStringTableMT._work_doTextColor;begin FTextColor:= ToInteger(_Data);Control.LVTextColor:= FTextColor;Control.Invalidate;end;
procedure ThiStringTableMT._work_doTextBkColor;begin FTextBkColor:= ToInteger(_Data);Control.LVTextBkColor:= FTextBkColor;Control.Invalidate;end;
procedure ThiStringTableMT._work_doBkColor;begin FBkColor:= ToInteger(_Data);Control.LVBkColor:= FBkColor;Control.Invalidate;end;
procedure ThiStringTableMT._work_doTranspColor;begin FTransparent:= ToInteger(_Data);end;
procedure ThiStringTableMT._work_doAutoMakeVisible;begin FAutoMakeVisible:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doStyle;begin FStyle:= TListViewStyle(ToInteger(_Data));Control.LVStyle:= FStyle;SetColumns(Clist,1);end;
procedure ThiStringTableMT._work_doTextAlign;begin FTextAlign:= TTextAlign(ToInteger(_Data));end;
procedure ThiStringTableMT._work_doSaveColProp;begin FSaveColProp:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doSaveWidth;begin FSaveWidth:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doSaveImgIndex;begin FSaveImgIndex:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doSaveItemsColor;begin FSaveItemsColor:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doSaveColor;begin FSaveColor:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doStaticColumn;begin FStaticColumn:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doSelectFind;begin FSelectFind:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doMethodSort;begin FMethodSort:= ToInteger(_Data);end;
procedure ThiStringTableMT._work_doTableWBreak;begin FTableWBreak:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTableMT._work_doGrid3D;begin FGrid3D:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTableMT._work_doBumpText;begin FBumpText:= ReadBool(_Data);Control.Invalidate;end;
procedure ThiStringTableMT._work_doModeMakeVisible;begin FModeMakeVisible:= ToInteger(_Data);end;
procedure ThiStringTableMT._work_doStyleGrid3D;begin FStyleGrid3D:= ToInteger(_Data);Control.Invalidate;end;
procedure ThiStringTableMT._work_doEnableOnClick;begin FEnableOnClick:= ReadBool(_Data);end;
procedure ThiStringTableMT._work_doReplaceFind;begin FFindReplace:= ReadBool(_Data);end;

procedure ThiStringTableMT._work_doGrid;
begin
   FGrid:= ReadBool(_Data);
   SetOption(FGrid,lvoGridLines);
end;

procedure ThiStringTableMT._work_doFlat;
begin
   FFlat:= ReadBool(_Data);
   SetOption(FFlat,lvoFlatsb);
end;

procedure ThiStringTableMT._work_doHeaderDragDrop;
begin
   FHeaderDragDrop:= ReadBool(_Data);
   SetOption(FHeaderDragDrop,lvoHeaderDragDrop);
end;

procedure ThiStringTableMT._work_doTrackSelect;
begin
   FTrackSelect:= ReadBool(_Data);
   SetOption(FTrackSelect,lvoTrackSelect);
end;

procedure ThiStringTableMT._work_doRowSelect;
begin
   FRowSelect:= ReadBool(_Data);
   SetOption(FRowSelect,lvoRowSelect);
end;

procedure ThiStringTableMT._work_doCheckBoxes;
begin
   if FExtIconsCheck then exit;
   FCheckBoxes:= ReadBool(_Data);
   SetOption(FCheckBoxes,lvoCheckBoxes);
   if ComboBox.Visible = True then _FlagRedraw:= True;
end;

procedure ThiStringTableMT._work_doMultiSelect;
begin
   if Assigned(ComboBox) then exit;
   FMultiSelect:= ReadBool(_Data);
   SetOption(FMultiSelect,lvoMultiSelect);
end;

procedure ThiStringTableMT._work_doInfoTip;
begin
   FInfoTip:= ReadBool(_Data);
   SetOption(FInfoTip,lvoInfoTip);
end;

procedure ThiStringTableMT.SetOption;
var   l:TListViewOptions;
begin
   l:= Control.LVOptions;
   if OSet then include(l,Option)
   else exclude(l,Option);
   Control.LVOptions:= l;
end;

//#####################################################################
//#                                                                   #
//#                               #
//#                                                                   #
//#####################################################################

//------------------         --------------------

//ColumnArray -    
//
procedure ThiStringTableMT._var_ColumnArray;
begin
  if not Assigned(CLArray) then
     CLArray := CreateArray(_SetCol,_GetCol,_CountCol,_AddCol);
  dtArray(_Data,CLArray);
end;

procedure ThiStringTableMT._SetCol(var Item:TData; var Val:TData);
var   s:string;
      ind:integer;
begin
   ind:= ToIntIndex(Item);
   s:= ToString(Val);
   if(ind >= 0)and(ind < CList.Count) then CList.Items[ind]:=InitColStr(s);
   SetColumns(CList,1);
end;

function ThiStringTableMT._GetCol(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   ind:= ToIntIndex(Item);
   Result:= True;
   if(ind >= 0)and(ind < CList.Count) then
      dtString(Val,Clist.Items[ind])
   else Result:= False;
end;

function ThiStringTableMT._CountCol:integer;
begin
   Result:= CList.Count;
end;

procedure ThiStringTableMT._AddCol(var Val:TData);
begin
   _work_doAddColumn(Val,0);
end;

//--------------------       -----------------------

//doAddColumn -     .    
//             (: == =  (0 - taLeft; 1 - taRight; 2 - taCenter))
//
procedure ThiStringTableMT._work_doAddColumn;
var   s:string;
begin
   s:= ToString(_Data);
   Control.LVColAdd('',FTextAlign,FColumnWidth);
   CList.Add(InitColStr(s));
   SetColumns(CList,1);
   if integer(Index) = 0 then exit;
   _hi_CreateEvent_(_Data,@_event_onChangeColLst);
end;

//doDeleteCol -        
//
procedure ThiStringTableMT._work_doDeleteCol;
var   ind:integer;
begin
   ind:= ToInteger(_Data);
   if(ind >= 0)and(ind < CList.Count) then
      begin
         Control.LVColDelete(ind);
         CList.Delete(ind);
      end;
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeColLst);
end;

//doClearCol -       
//
procedure ThiStringTableMT._work_doClearCol;
var   x,y:integer;
      dt:TData;
begin
    dtNull(dt);
    x:= ToInteger(_Data);
    if(x >= 0)and(x < CList.Count) then
       for y:= 0 to Control.Count - 1 do MX_Set(x,y,dt);
   Control.Invalidate;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

function ThiStringTableMT.InitColStr;
var   s,ss,sd,se,sf,sh:string;
begin
   s:= val;
   sf:= s + '=';
   ss:= GetTok(sf,'=');
   sd:= GetTok(sf,'=');
   sh:= GetTok(sf,'=');
   se:= GetTok(sf,'=');
   if s = '' then s:= '=' + int2str(FColumnWidth) + '=' + int2str(integer(FTextAlign))
   else begin
      if sd = '' then sd:= int2str(FColumnWidth);
      if se = '' then se:= int2str(integer(FTextAlign));
      s:= ss + '=' + sd + '=' + sh + '=' + se;
   end;
   Result:= s;
end;

//--------------------       ----------------------

//CountCol -   
//
procedure ThiStringTableMT._var_CountCol;
begin
   dtInteger(_Data,CList.Count);
end;

//EndIdxCol -    
//
procedure ThiStringTableMT._var_EndIdxCol;
begin
   if CList.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,CList.Count - 1);
end;

//#####################################################################
//#                                                                   #
//#                                                #
//#                                                                   #
//#####################################################################

//Matrix -  
//
procedure ThiStringTableMT._var_Matrix;
begin
   if not Assigned(Obj) then begin
      New(Obj);
      Obj._Set:= MX_Set;
      Obj._Get:= MX_Get;
   end;
   dtMatrix(_Data,Obj);
end;

function ThiStringTableMT.MX_Get;
begin
   if(x >= 0)and(y >= 0)and(y < Control.Count)and(x < Control.LVColCount) then
      dtString(Result,Control.LVItems[y,x])
   else dtNull(Result);
end;

procedure ThiStringTableMT.MX_Set;
begin
   if(x >= 0)and(y >= 0)and(y < Control.Count)and(x < Control.LVColCount) then
     Control.LVItems[y,x]:= ToString(Val);
end;

//#####################################################################
//#                                                                   #
//#                                     #
//#                                                                   #
//#####################################################################

//-----------------        -------------------

procedure ThiStringTableMT.SetIcons;
var i:integer;
begin
   if not FAssignedIList then exit;
   IList:= NewImageList(Control);
   if FImgsize = 0 then FImgsize:= GetSystemMetrics(SM_CXICON);
   SetIListProp;
   for i:= 0 to Value.Count - 1 do IList.AddIcon(Value.Objects[i]);
end;

//-------------        ----------------

procedure ThiStringTableMT.SetIconsCheck;
var i:integer;
begin
   IChList:= NewImageList(Control);
   IChList.BkColor:= FBkColor;
   IChList.ImgWidth:= FImgSize;
   IChList.ImgHeight:= FImgSize;
   for i:= 0 to Value.Count - 1 do IChList.AddIcon(Value.Objects[i]);
end;

//----------        ------------

procedure ThiStringTableMT.SetMiscIcons;
begin
   IDList:= NewStrListEx;
   IDList.Assign(Value);
end;

//--------          ----------

procedure ThiStringTableMT.SetIListProp;
begin
   IList.BkColor:= FIconColColor;
   IList.ImgWidth:= FImgSize;
   IList.ImgHeight:= FImgSize;
end;

//-------------------         ---------------------

//IconArray -  
//
procedure ThiStringTableMT._var_IconArray;
begin
  if Assigned(Ilist) then
     begin
        if not Assigned(ICArray) then ICArray := CreateArray(_SetIcon,_GetIcon,_CountIcon,_AddIcon);
        dtArray(_Data,ICArray);
     end
  else dtArray(_Data,nil);
end;

procedure ThiStringTableMT._SetIcon(var Item:TData; var Val:TData);
var   ind:integer;
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) and _IsIcon(Val) then
      IList.ReplaceIcon(ind, ToIcon(val).handle);
   Control.Invalidate;
end;

function ThiStringTableMT._GetIcon(Var Item:TData; var Val:TData):boolean;
var   ind:integer;
begin
   Result:= False;
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   ind:= ToIntIndex(Item);
   if (ind >= 0)and(ind < IList.Count) then begin
      Icon.Clear;
      Icon.Handle:= IList.ExtractIcon(ind);
      dtIcon(Val,Icon);
      Result:= True;
   end;
end;

function ThiStringTableMT._CountIcon:integer;
begin
   Result:=0;
   if not Assigned(Ilist) then Exit;
   Result:= IList.Count;
end;

procedure ThiStringTableMT._AddIcon(var Val:TData);
begin
   if not Assigned(Ilist) then Exit;
   SetIListProp;
   if _IsIcon(Val) then IList.AddIcon(ToIcon(Val).Handle);
   Control.Invalidate;
end;

//-----------------        ---------------------

//doDeleteIcon -         
//
procedure ThiStringTableMT._work_doDeleteIcon;
var   ind:integer;
begin
   ind:= ToInteger(_Data);
   if not (Assigned(IList) and (ind >= 0) and (ind < IList.Count)) then Exit;
   IList.Delete(ind);
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeImgLst);
end;

//doGetIcon=         
//
procedure ThiStringTableMT._work_doGetIcon;
var   dt,di:TData;
      bmp:PBitmap;
begin
   dtNull(di);
   bmp:= nil;
   Icon.Clear;
   if Assigned(IList) and (Ilist.Count <> 0) then
      if _GetIcon(_Data,dt) then Icon{$ifndef F_P}^{$endif} := ToIcon(dt){$ifndef F_P}^{$endif} ;
   if Icon.Handle <> 0 then
      if FIconToBmp then begin
         bmp:= NewDIBBitmap(Icon.Size,Icon.Size,pf32bit);
         bmp.Handle:= Icon.Convert2Bitmap(FTransparent);
         dtBitmap(di,bmp);
      end
      else dtIcon(di,Icon);
   _hi_onEvent(_event_onGetIcon,di);
   If Assigned(bmp) then bmp.free;
end;

//doGetIconIdx -         
//
procedure ThiStringTableMT._work_doGetIconIdx;
var   idx,ind:integer;
begin
   ind:= ToInteger(_Data);
   idx:= -1;
   if Assigned(IList)and(Ilist.Count <> 0)and(Control.Count<>0) then
      idx:= Control.LVItemImageIndex[ind]; 
   _hi_CreateEvent(_Data,@_event_onGetIconIdx,idx);
end;

procedure ThiStringTableMT.InsertIcon;
var   dt:TData;
      i,ind:integer;
begin
   dt:= Data;
   ind:= integer(Index);
   if not (Assigned(IList)and _IsIcon(dt)and(ind >= 0)and(ind < IList.Count)) then exit;
   i:= IList.Count - 1;
   IList.AddIcon(IList.ExtractIcon(i));
   repeat
      IList.ReplaceIcon(i,IList.ExtractIcon(i-1));
      dec(i);            
   until i <= ind;
   IList.ReplaceIcon(ind, ToIcon(dt).handle);
   SetColumns(CList,1);
end;

//doClearIcons -   
//
procedure ThiStringTableMT._work_doClearIcons;
begin
   ClearIcons;
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeImgLst);
end;

procedure ThiStringTableMT.ClearIcons;
begin
   if (not Assigned(IList)) or (Ilist.Count = 0) then Exit;
   repeat
     IList.Delete(Ilist.Count - 1);
   until Ilist.Count = 0;
   IList.Clear;
   Control.Invalidate;
end;

//--------------        -----------------

//doGetMiscIcon -           
//
Procedure ThiStringTableMT._work_doGetMiscIcon;
var   ind:integer;
      bmp:PBitmap;
      di:TData;
begin
   dtNull(di);
   bmp:= nil;
   ind:= ToInteger(_Data);
   if ind > IDList.Count - 1 then exit;
   Icon.Clear;
   Icon.Handle:= IDList.Objects[ind];
   if Icon.Handle <> 0 then
      if FIconToBmp then
         begin
            bmp:= NewDIBBitmap(Icon.Size,Icon.Size,pf32bit);
            bmp.Handle:= Icon.Convert2Bitmap(FTransparent);
            dtBitmap(di,bmp);
         end
      else dtIcon(di,Icon);
   _hi_onEvent(_event_onGetMiscIcon,di);
   If Assigned(bmp) then bmp.free;
end;

//----------------         -------------------

//doLoadPakIcons -      (*.exe,*.dll,*.ocx,*.icl)   
//
procedure ThiStringTableMT._work_doLoadPakIcons;
var   i,IconCount:integer;
      fn:string;
begin
   if not Assigned(IList) then exit;
   fn:= ReadString(_Data,_data_IconsFileName,_prop_IconsFileName);
   if not LFileExists_MT(fn,LOAD_PAK_ICONS) then Exit;
   Icon.Clear;
   IconCount:= GetFileIconCount(fn);
   if IconCount <> 0 then begin
      ClearIcons;
      i:= 0;
      repeat
         Icon.LoadFromExecutable(fn,i);
         SetIListProp;
         IList.AddIcon(Icon.Handle);
         inc(i);
      until i = IconCount;
   end;
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeImgLst);
end;

//doLoadIcon -    ,          ,
//                 ,     
//
procedure ThiStringTableMT._work_doLoadIcon;
var   ind:integer;
      fn:string;
      dt:TData;
begin
   if not Assigned(IList) then exit;
   ind:=Tointeger(_Data);
   fn:= ReadString(_Data,_data_IconFileName,_prop_IconFileName);
   if not LFileExists_MT(fn,LOAD_ICON) then Exit;
   Icon.Clear;
   Icon.LoadFromFile(fn);
   dtIcon(dt,Icon);
   if (ind >= IList.Count) or (ind < 0) then _AddIcon(dt)
   else if (ind >= 0 ) and (ind < IList.Count ) then InsertIcon(dt,ind);
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeImgLst);
end;

//doSaveIcon -        
//
procedure ThiStringTableMT._work_doSaveIcon;
var   dt,di:TData;
      fn:string;
      Pos:Integer;
      Bitmaps:array of HBitmap;
      II:TIconInfo;
      Strm, st:PStream;
begin
   if not Assigned(IList) then exit;
   di:= _Data;
   fn:= ReadString(_Data,_data_IconFileName,_prop_IconFileName);
   if SFileExists_MT(fn,SAVE_ICON_FILE) then Exit;
   Icon.Clear;
   if _GetIcon(di,dt) then Icon{$ifndef F_P}^{$endif} := ToIcon(dt){$ifndef F_P}^{$endif} ;
   st:= NewWriteFileStream(fn);
   Strm:= NewMemoryStream;
   Pos:= Strm.Position;
   SetLength(Bitmaps, 2);
   GetIconInfo(Icon.Handle,II);
   Bitmaps[0]:= II.hbmColor;
   Bitmaps[1]:= II.hbmMask;
   if not SaveIcons2StreamEx(Bitmaps,Strm) then Strm.Seek(Pos,spBegin);
   Strm.Position:= 0;
   Stream2Stream(st,Strm,Strm.Size);
   st.free;
   Strm.free;
end;

//-------------------        ---------------------

//doSaveIList -     
//
procedure ThiStringTableMT._work_doSaveIList;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_IListFileName,_prop_IListFileName);
   if SFileExists_MT(fn,SAVE_ILIST) then Exit;
   SaveIListToFile(fn,Index);
end;

procedure ThiStringTableMT.SaveIListToFile;
var   Strm, st:PStream;
      i,Pos:Integer;
      Bitmaps:array of HBitmap;
      II:TIconInfo;
      Bmp:HBitmap;
begin
   if not Assigned(Ilist) then Exit;
   for I:= 0 to IList.Count - 1 do if IList.ExtractIcon(I) = 0 then Exit;
   Strm:= NewMemoryStream;
   Pos:= Strm.Position;
   SetLength(Bitmaps, IList.Count * 2);
   for I:= 0 to IList.Count - 1 do begin
      GetIconInfo(IList.ExtractIcon(I),II);
      Bitmaps[I * 2]:= II.hbmColor;
      Bitmaps[I * 2 + 1]:= II.hbmMask;
   end;
   if not SaveIcons2StreamEx(Bitmaps,Strm) then Strm.Seek(Pos,spBegin);
   for i:= 0 to High(Bitmaps) do begin
      Bmp:= Bitmaps[i];
      if Bmp <> 0 then DeleteObject(Bmp);
   end;
   If Index <> 0 then begin
      st:= NewWriteFileStream(FileName);
      Strm.Position:= 0;
      Stream2Stream(st,Strm,Strm.Size);
      st.free;
   end
   else begin
      Strm.Position:= 0;
      Stream2Stream(SICLStream,Strm,Strm.Size);
   end;
   Strm.free;
end;

//-------------------        ----------------------

//doLoadIList -     
//
procedure ThiStringTableMT._work_doLoadIList;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_IListFileName,_prop_IListFileName);
   if not LFileExists_MT(fn,LOAD_PAK_ICONS) then Exit;
   LoadIListFromFile(fn,1);
   SetColumns(CList,1);
end;

procedure ThiStringTableMT.LoadIListFromFile;
var   Strm, st: PStream;
      Pos: DWord;
      Data: TStreamData;

   function ReadIcon : Boolean;
   var   IDI, FoundIDI : TIconDirEntry;
         I, j: Integer;
         II : TIconInfo;
         BIH : TBitmapInfoheader;
         IH : TIconHeader;
         Mem: PStream;
         ImgBmp, MskBmp : PBitmap;
   begin
      ImgBmp:= nil;
      MskBmp:= nil;
      Result:= False;
      if Strm.Read(IH, Sizeof(IH)) <> Sizeof(IH) then Exit;
      if (IH.idReserved <> 0) or ((IH.idType <> 1) and (IH.idType <> 2)) or
         (IH.idCount < 1) then exit;
      for j:= 1 to IH.idCount do begin
         if Strm.Read(IDI, Sizeof(IDI)) <> Sizeof(IDI) then Exit;
         if (IDI.bWidth <> IDI.bHeight) and (IDI.bWidth * 2 <> IDI.bHeight) or 
            (IDI.bWidth = 0) then exit;
         FoundIDI:= IDI;
         Strm.Seek(Integer(Pos) + (FoundIDI.dwImageOffset), spBegin);
         Data.fSize:= FoundIDI.bWidth;
         if Strm.Read(BIH, Sizeof(BIH)) <> Sizeof(BIH) then Exit;
         if (BIH.biWidth <> integer(Data.fSize)) or (BIH.biHeight <> integer(Data.fSize) * 2) and
            (BIH.biHeight <> integer(Data.fSize)) then exit;
         BIH.biHeight:= Data.fSize;
         Mem:= NewMemoryStream;
      TRY
         Mem.Write(BIH, Sizeof(BIH));
         if (FoundIDI.bColorCount >= 2) or (FoundIDI.bReserved = 1) or (FoundIDI.bColorCount = 0) then begin
            I:= 0;
            if BIH.biBitCount <= 8 then I := (1 shl BIH.biBitCount) * Sizeof(TRGBQuad);
            if I > 0 then if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
            I:= ((BIH.biBitCount * Data.fSize + 31) div 32) * 4 * Data.fSize;
            if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
            ImgBmp:= NewDIBBitmap(Data.fSize, Data.fSize,pf32bit);
            Mem.Seek(0, spBegin);
            ImgBmp.LoadFromStream(Mem);
            if ImgBmp.Empty then exit;
         end;
         BIH.biBitCount:= 1;
         Mem.Seek(0, spBegin);
         Mem.Write(BIH, Sizeof(BIH));
         I:= 0;
         Mem.Write(I, Sizeof(I));
         I:= $FFFFFF;
         Mem.Write(I, Sizeof(I));
         I:= ((Data.fSize + 31) div 32) * 4 * Data.fSize;
         if Stream2Stream(Mem, Strm, I) <> DWORD(I) then exit;
         MskBmp:= NewDIBBitmap(Data.fSize,Data.fSize,pf32bit);
         Mem.Seek(0, spBegin);
         MskBmp.LoadFromStream(Mem);
         if MskBmp.Empty then exit;
         FillChar(II, Sizeof(II), 0);
         II.fIcon:= True;
         II.xHotspot:= 0;
         II.yHotspot:= 0;
         II.hbmMask:= MskBmp.ReleaseHandle;
         II.hbmColor:= ImgBmp.ReleaseHandle;
         Data.fHandle:= CreateIconIndirect(II);
         SetIListProp;
         IList.AddIcon(Data.fHandle);
         DestroyIcon(Data.fHandle);
         DeleteObject(II.hbmMask);
         DeleteObject(II.hbmColor);         
         Strm.Seek(integer(Pos) + Sizeof(IH) +  Sizeof(IDI)*j, spBegin);
      FINALLY
         if Assigned(ImgBmp) then ImgBmp.free;
         if Assigned(MskBmp) then MskBmp.free;
         Mem.free;      
      END;
      end;
      Result:= Data.fHandle <> 0;
   end;

begin
   Strm:= NewMemoryStream;
   if ((Index = 0) and not Assigned(LICLStream)) or not Assigned(IList) then exit;
   if ((Index = 0) and (LICLStream.Size = 0)) then exit; 
   if (Index = 0) then begin
     LICLStream.Position:= 0;
     Stream2Stream(Strm,LICLStream,LICLStream.Size);
   end
   else begin
      st:= NewReadFileStream(Filename);
      Stream2Stream(Strm,st,st.Size);
      st.free;
   end;
   ClearIcons;
   Strm.Position:= 0;
   Data:= Strm.Data;
   Pos:= Data.fPosition;
   ReadIcon;
   Strm.free;
   Control.Invalidate;
   _hi_onEvent(_event_onChangeImgLst);
end;

//------------------        ---------------------

//CountIcons -       
//
procedure ThiStringTableMT._var_CountIcons;
begin
   dtInteger(_Data,IList.Count);
end;

//EndIdxIcons -        
//
procedure ThiStringTableMT._var_EndIdxIcons;
begin
   if IList.Count = 0 then dtNull(_Data) 
   else dtInteger(_Data,IList.Count - 1);
end;

//#####################################################################
//#                                                                   #
//#                                              #
//#                                                                   #
//#####################################################################

//--------------         --------------

//LFileExists_MT -         ,
//                     . MT-   -
//                 - (   (0 - Load, 2 - LoadIcon, 4 - LoadPakIcons,
//                 5 - LoadIList, 7 - LoadExtIcon, 10 - LoadStrLst)( )
//
function ThiStringTableMT.LFileExists_MT;
var dt1,dt2:TData;
begin
   Result:= True;
   if FileExists(FileName) then Exit;
   dtInteger(dt1, FileOperation);
   dtString(dt2, FileName);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_LFileExists_MT);
   Result:=False;
end;

//--------------         --------------

//SFileExists_MT -         0,
//                     ,  - ,
//                 MT-   - (   (1 - Save,
//                 3 - SaveIcon, 6 - SaveIList, 8 - SaveStrLst, 9 - AppendStrLst)( )
//
function ThiStringTableMT.SFileExists_MT;
var dt1,dt2:TData;
begin
   Result:= False;
   if not FileExists(FileName) then Exit;
   dtInteger(dt1, FileOperation);
   dtString(dt2, FileName);
   dt1.ldata := @dt2;
   _ReadData(dt1, _data_SFileExists_MT); 
   if ToInteger(dt1) <> 0 then Result:= True;
end;

//---------------        ---------------

//EndEdit -         0,
//               
//
procedure ThiStringTableMT._work_doEndEdit;
begin
   if not FRedaction then Exit;
   if  ReadInteger(_Data,_data_EndEdit,0) = 0 then
      Control.Perform(WM_KEYDOWN,27,0)
   else
      Control.Perform(WM_JUSTFREE,0,0);
end;

//#####################################################################
//#                                                                   #
//#                    /                     #
//#                                                                   #
//#####################################################################

//----------------------       -----------------------

//doSave -    
//
procedure ThiStringTableMT._work_doSave;
var   i,j,p:integer;
      lst:PStrList;
      str,fn,s,sa,sb:string;
      Count:dword;
begin
   lst:= NewStrList;
   lst.Add('');
   FTblStream.free;
   FTblStream:= NewMemoryStream;
   STblStream:= NewMemoryStream;
   SIClStream:= NewMemoryStream;
TRY
   if Index <> 0 then begin
      fn:= ReadString(_Data,_data_FileName,_prop_FileName);
      if SFileExists_MT(fn,SAVE_TABLE) then Exit;
   end;
   if not FSaveWidth then
      str:= CList.text
   else begin
      for i:= 0 to CList.Count - 1 do begin
         s:= CList.Items[i];
         sa:= GetTok(s,'=');
         sb:= GetTok(s,'=');
         sb:= int2str(Control.LVColWidth[i]);
         CList.Items[i]:= sa + '=' + sb + '=' + s; 
      end;
      str:= CList.text;
   end;
   Replace(str,#13#10,_StrDlm);
   if not FStaticColumn then begin
      if FSaveColProp then
         if FSaveColor then
            lst.Items[0]:= int2str(Color2RGB(FTextColor)) + _ColorDlm + int2str(Color2RGB(FTextBkColor)) + _ColorDlm + int2str(Color2RGB(FBkColor)) + _ColorDlm + int2str(Color2RGB(FTransparent)) + _ColorDlm + str
         else lst.Items[0]:= str
      else begin
         for i:= 0 to Control.LVColCount - 1 do
            if i = 0 then lst.Items[0]:= Control.LVColText[i]
            else lst.Items[0]:= lst.Items[0] + _StrDlm + Control.LVColText[i];
      end;
      p:= 1;
      end
   else p:= 0;
   if (Control.Count > 0)and(Control.LVColCount > 0) then
      for i:= 0 to Control.Count - 1 do begin
         lst.Add('');
         for j:= 0 to Control.LVColCount - 1 do
            if j = 0 then begin
               lst.Items[i+p]:= '';
               if FSaveImgIndex then lst.Items[i+p]:= int2str(Control.LVItemImageIndex[i]) + _StrDlm;
               if FSaveItemsColor then lst.Items[i+p]:= lst.Items[i+p] + PakColor2Str(Control.LVItemData[i]) + _StrDlm;         
               lst.Items[i+p]:= lst.Items[i+p] + Control.LVItems[i,j];
            end
            else lst.Items[i+p]:= lst.Items[i+p] + _StrDlm + Control.LVItems[i,j];
      end;
   if p = 0 then lst.Delete(Control.Count);
   if Index = 0 then
      lst.SaveToStream(STblStream)
   else
      lst.SaveToFile(fn);
   if Index <> 0 then Exit;
   SaveIListToFile('',0);
   STblStream.Position:= 0;
   SICLStream.Position:= 0;
   Count:= STblStream.Size; 
   FTblStream.Write(Count,4);
   Stream2Stream(FTblStream,STblStream,STblStream.Size);
   Count:= SICLStream.Size;
   FTblStream.Write(Count,4);
   Stream2Stream(FTblStream,SICLStream,SICLStream.Size);   
FINALLY
   lst.free;
   STblStream.free;
   SICLStream.free;
END;
end;

//-----------------------       ------------------------

//doLoad -    
//
procedure ThiStringTableMT._work_doLoad;
var   i,p:integer;
      lst:PStrList;
      s,sa,tc,tbc,bc,tr,fn:string;
      dt:TData;
      Count:dword;
begin
   if Index = 0 then begin
      dtNull(dt);
      LoadStream:= ReadStream(dt,_data_FTblStream,nil);
      if LoadStream = nil then exit; 
      LTblStream:= NewMemoryStream;
      LICLStream:= NewMemoryStream; 
      LoadStream.Position:= 0;
      LoadStream.Read(Count,4);
      Stream2Stream(LTblStream,LoadStream,Count);
      LoadStream.Read(Count,4);               
      Stream2Stream(LICLStream,LoadStream,Count);
      if LICLStream.Size <> 0 then LoadIListFromFile('',0);
      if LTblStream.Size = 0 then exit;
      LTblStream.Position:= 0;
      lst:= NewStrList;
      lst.LoadFromStream(LTblStream,False);
      LICLStream.free;
      LTblStream.free;
   end
   else begin
      fn:= ReadString(_Data,_data_FileName,_prop_FileName);
      if not LFileExists_MT(fn,LOAD_TABLE) then Exit; 
      lst:= NewStrList;
      lst.LoadFromFile(fn);
   end;
   Control.Clear;
   if not FStaticColumn then begin
      while Control.LVColCount > 0 do Control.LVColDelete(0);
      if lst.Count > 0 then begin
         sa:= lst.Items[0];
         s := sa + _ColorDlm;
         tc:= gettok(s,_ColorDlm);
         tbc:=gettok(s,_ColorDlm);
         if (tc <> '') and (tbc ='') then begin
            tc:= ''; bc:= ''; tr:= ''; s:= sa;
         end
         else begin
            bc:= gettok(s,_ColorDlm);
            tr:= gettok(s,_ColorDlm);
            if (tc <> '') and (tbc <> '') and (bc <> '') and (tr <> '') then begin
               dtString(dt,tc); _work_doTextColor(dt,0);
               dtString(dt,tbc); _work_doTextBkColor(dt,0);
               dtString(dt,bc); _work_doBkColor(dt,0);
               dtString(dt,tr); _work_doTranspColor(dt,0);
            end;
         end;         
         Replace(s,_ColorDlm,'');
         Replace(s,_StrDlm,#13#10);
         CList.text:= s;
         SetColumns(CList,0);
      end;
      p:= 1;
   end else p:= 0;
   if lst.Count > 0 then begin
      for i:= p to lst.Count - 1 do Add(lst.Items[i]);
      Control.Invalidate;
   end;
   lst.free;
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doSaveFStream -      
//
procedure ThiStringTableMT._work_doSaveFStream;
begin
   _work_doSave(_Data,0);
end;

//doLoadFStream -      
//
procedure ThiStringTableMT._work_doLoadFStream;
begin
   _work_doLoad(_Data,0);
end;

//FStream -        doLoadFStream  doSaveFStream
//
procedure ThiStringTableMT._var_FStream;
begin
   if not Assigned(FTblStream) then exit; 
   dtNull(_Data);
   dtStream(_Data,FTblStream);
end;

//---------------------       ----------------------

procedure ThiStringTableMT.SetTextStrLst;
begin
   FList:= NewStrList;
   Flist.Text:= Value;
end;

//doAddStrLst -     
//
procedure ThiStringTableMT._work_doAddStrLst;
begin
   FList.Add(ReadString(_Data,_data_StrLst,''));
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doTblStrLst -      
//
procedure ThiStringTableMT._work_doTblStrLst;
var   ind:integer;
begin
   if not FAppTxtStrLst then Control.Clear;
   for ind:= 0 to FList.Count - 1 do Add(FList.Items[ind]);
   _hi_CreateEvent_(_Data,@_event_onChange);
end;

//doGetStrList -         
//
procedure ThiStringTableMT._work_doGetStrList;
var   ind:integer;
      s:string;
begin
   ind := ToIntIndex(_Data);
   s:= '';
   if(ind >= 0)and(ind < FList.Count)then s:= FList.Items[ind];
   _hi_onEvent(_event_onGetStrList,s);
end;

//doClearStrLst -   
//
procedure ThiStringTableMT._work_doClearStrLst;
begin
   FList.Clear;
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doDeleteStrLst -        
//
procedure ThiStringTableMT._work_doDeleteStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if not ((ind >= 0)and(ind < FList.Count)) then exit;
   FList.Delete(ind);
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doLoadStrLst -        
//
procedure ThiStringTableMT._work_doLoadStrLst;
var   fn:string;
      Strm:PStream;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if not LFileExists_MT(fn,LOAD_STRING_LIST) then Exit;
   Strm:= NewReadFileStream(fn);
   Strm.Position:= 0;
   FList.LoadFromStream(Strm, false);
   Strm.free;
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doSaveStrLst -        
//
procedure ThiStringTableMT._work_doSaveStrLst;
var   fn:string;
      Strm:PStream;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if SFileExists_MT(fn,SAVE_STRING_LIST) then Exit;
   Strm:= NewWriteFileStream(fn);
   Strm.Position:= 0;
   FList.SaveToStream(Strm);
   Strm.free;
end;

//doAppendStrFile -       
//
procedure ThiStringTableMT._work_doAppendStrFile;
var   fn:string;
begin
   fn:= ReadString(_Data,_data_StrLstFName,_prop_StrLstFName);
   if SFileExists_MT(fn,APPEND_STRING_FILE) then Exit;
   FList.AppendToFile(fn);
end;

//doInsertStrLst -      StrList      
//
procedure ThiStringTableMT._work_doInsertStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(_Data);
   if not ((ind >= 0) and (ind < FList.Count)) then Exit;
   FList.Insert(ind, ReadString(_Data,_data_StrLst,''));
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doTextStrLst -      : <1,2,...>
//
procedure ThiStringTableMT._work_doTextStrLst;
begin
   FList.Text:= ReadString(_Data,_data_StrLst,'');
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doAddTextStrLst -        
//
procedure ThiStringTableMT._work_doAddTextStrLst;
begin
   FList.Text:= FList.Text + ReadString(_Data,_data_StrLst,'');
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//doSortStrLst -    
//
procedure ThiStringTableMT._work_doSortStrLst;
begin
   FList.Sort(false);
   _hi_CreateEvent_(_Data,@_event_onChangeStrLst);
end;

//CountStrLst -      
//
procedure ThiStringTableMT._var_CountStrLst;
begin
   dtInteger(_Data,FList.Count);
end;

//EndIdxStrLst -       
//
procedure ThiStringTableMT._var_EndIdxStrLst;
begin
   if FList.Count = 0 then dtNull(_Data)
   else dtInteger(_Data,FList.Count - 1);
end;

//TextStrLst -     ,   10  13
//
procedure ThiStringTableMT._var_TextStrLst;
begin
   dtString(_Data,FList.Text);     
end;

//StrLstArray -    
//
procedure ThiStringTableMT._var_StrLstArray;
begin
   if SLArray = nil then
      SLArray:= CreateArray(_SetStrLst, _GetStrLst, _CountStrLst, _AddStrLst);
   dtArray(_Data,SLArray);
end;

procedure ThiStringTableMT._SetStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < FList.Count)then
      FList.Items[ind]:= ToString(Val);
end;

function ThiStringTableMT._GetStrLst;
var   ind:integer;
begin
   ind := ToIntIndex(Item);
   if(ind >= 0)and(ind < FList.Count)then begin
      Result:= true;
      dtString(Val,FList.Items[ind]);
   end
   else Result:= false;
end;

function ThiStringTableMT._CountStrLst;
begin
   Result:= FList.Count;
end;

procedure ThiStringTableMT._AddStrLst;
begin
   FList.Add(ToString(val));
end;

//#####################################################################
//#                                                                   #
//#                      ComboBox'                        #
//#                                                                   #
//#####################################################################

//doEnableCombo - / ComboBox. 1 - , 0 - 
//
procedure ThiStringTableMT._work_doEnableCombo;
begin
   if not Assigned(ComboBox) then Exit;
   if boolean(ToInteger(_Data)) then begin
      FComboBox:= True; 
      ComboBox.Color:= Control.Color;
      if FComboTextColor then ComboBox.Font.Color:= FTextColor;
   end
   else begin
      FComboBox:= False;
      ComboBox.Visible:= False;
   end;
   _FlagCombo:= FComboBox and not FRedaction;
   if FTypeComboInit = 2 then _work_doComboInit(_Data,Index);
end;

//doComboColumn -    ComboBox'a
//
procedure ThiStringTableMT._work_doComboColumn;
var   idx:integer;
begin
   if not Assigned(ComboBox) or not _FlagCombo then Exit;
   idx:= ToInteger(_Data);
   if idx < 0 then exit
   else if idx > Clist.Count - 1 then idx:= Clist.Count - 1;   
   ComboCol:= idx;
   ComboBox.Visible:= False;
   Control.LVCurItem:= -1;
   ComboBox.CurIndex:= -1;
   ComboBox.Perform(WM_KEYDOWN,27,0);
   Control.LVCurItem:= ComboItem;
   if FTypeComboInit = 2 then _work_doComboInit(_Data,Index);
   ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(Control.LVItems[ComboItem,ComboCol])));
end;

//doComboInit -  ComboBox   TypeComboInit
//
procedure ThiStringTableMT._work_doComboInit;
var   d:PData;
      idx:integer;
      s:string;
begin
   if not Assigned(ComboBox) then Exit;
   ComboBox.Clear;
   case FTypeComboInit of
      0: if not FAutoTblStrLst then
            for idx := 0 to min((FList.Count - 1), (FMaxComboItem - 1)) do
               ComboBox.Add(FList.Items[idx]);  
      1: begin
            d := @_Data;
            idx:= 0;
            while (d <> nil) and not _IsNULL(d^) and
               (ComboBox.Count < FMaxComboItem) do begin
                  ComboBox.Items[idx]:= ToString(d^);
                  inc(idx);
                  d := d.ldata;
            end;
            if (d <> nil) and not _IsNULL(d^) then FreeData(d);
      end;
      2: begin
            idx:= 0;
            while (idx < Control.Count) and (ComboBox.Count < FMaxComboItem) do begin
               s:= Control.LVItems[idx, ComboCol]; 
               if ComboBox.Insert(0,'') = -1 then ComboBox.Add('');
               ComboBox.CurIndex:= 0;
               ComboBox.Perform(CB_SELECTSTRING,-1,integer(PChar(s)));
               if ComboBox.CurIndex > 0 then
                  ComboBox.Delete(0)
               else begin
                  ComboBox.Delete(0);
                  ComboBox.Add(s);
               end;   
               inc(idx);
            end;
         end;
   end;      
   ComboBox.Color:= Control.Color;
   if FComboTextColor then ComboBox.Font.Color:= FTextColor;
end;

//#####################################################################
//#                                                                   #
//#                           MT-                               #
//#                                                                   #
//#####################################################################

//doMT_Add -    ,  MT-,
//              -    
//
procedure ThiStringTableMT._work_doMT_Add;begin MT_ActionItm(_Data, ITM_ADD);end;

//doMT_Insert -    ,  MT-,
//                 - ( ),     
//
procedure ThiStringTableMT._work_doMT_Insert;begin MT_ActionItm(_Data, ITM_INSERT);end;

//doMT_Replace -    ,  MT-,
//                  - ( ),   
//
procedure ThiStringTableMT._work_doMT_Replace;begin MT_ActionItm(_Data, ITM_REPLACE);end;

//doMT_InsertCol -    ,  MT-,
//                    -
//                 - ( )(== =  (0 - taLeft; 1 - taRight; 2 - taCenter))
//
procedure ThiStringTableMT._work_doMT_InsertCol;begin MT_ActionCol(_Data, ITM_INSERT);end;

//doMT_ReplaceCol -    ,  MT-,
//                     -
//                  - ( )(== =  (0 - taLeft; 1 - taRight; 2 - taCenter))
//
procedure ThiStringTableMT._work_doMT_ReplaceCol;begin MT_ActionCol(_Data, ITM_REPLACE);end;

//doMT_InsertIcon -     ,  MT-,
//                     -
//                  - (    )().
//                        ,     
//
procedure ThiStringTableMT._work_doMT_InsertIcon;begin MT_ActionIco(_Data,ITM_INSERT);end;

//doMT_ReplaceIcon -     ,  MT-,
//                      -
//                   - (    )()
//
procedure ThiStringTableMT._work_doMT_ReplaceIcon;begin MT_ActionIco(_Data,ITM_REPLACE);end;

//doMT_NameCol -   ,  MT-,
//                  -
//               - ( )()
//
procedure ThiStringTableMT._work_doMT_NameCol;begin MT_ProperCol(_Data, COL_NAME);end;

//doMT_WidthCol -   ,  MT-,
//                   - 
//                - ( )()
//
procedure ThiStringTableMT._work_doMT_WidthCol;begin MT_ProperCol(_Data, COL_WIDTH);end;

//doMT_ImageCol -      ,  MT-,
//                   - 
//                - ( )( )
//
procedure ThiStringTableMT._work_doMT_ImageCol;begin MT_ProperCol(_Data, COL_IMAGE);end;

//doMT_AlignTxtCol -     ,  MT-,
//                      - 
//                   - ( )(  (0 - taLeft; 1 - taRight; 2 - taCenter))
//
procedure ThiStringTableMT._work_doMT_AlignTxtCol;begin MT_ProperCol(_Data, COL_ALIGN);end;

//doMT_EMatrix -  ()    ,  MT-,
//                  - 
//               - (X -  )(Y -  ).
//                  X -   .
//                  Y -  
//
procedure ThiStringTableMT._work_doMT_EMatrix;begin MT_EMatrix(_Data,EMATRIX);end;

//doMT_ChkEMatrix -  ()       ,  MT-,
//                     - 
//                  - (X -  )(Y -  ).
//                     X -   .
//                     Y -  
//
procedure ThiStringTableMT._work_doMT_ChkEMatrix;begin MT_EMatrix(_Data,CHK_EMATRIX);end;

//doMT_SelEMatrix -   ()    ,  MT-,
//                     -
//                  - (X -  )(Y -  ).
//                     X -   .
//                     Y -  
//
procedure ThiStringTableMT._work_doMT_SelEMatrix;begin MT_EMatrix(_Data,SEL_EMATRIX);end;

// MT-    
//
procedure ThiStringTableMT.MT_ActionItm; // 
var   Row,Col,iconum:integer;
      ss:string;
      DColor:dword;
begin
   Row:= Control.Count;
   if (Mode = ITM_INSERT) or (Mode = ITM_REPLACE) then
      if not _IsNULL(Data) then begin
         Row:= ReadInteger(Data,Null);   
         if (Row > Control.Count - 1) then exit;
      end;
   Col:= 0;
   iconum:= I_SKIP;
   DColor:= 0;
   if Assigned(Ilist) and not _IsNULL(Data) then begin
      iconum:= ReadInteger(Data,Null);
      if iconum > IList.Count - 1 then iconum:= I_SKIP;
   end;
   if FColorItems and not _IsNULL(Data) then begin
      ss:= ReadString(Data,Null) + _ColorDlm;
      DColor:= dword(Str2Int(GetTok(ss,_ColorDlm)) shl 24 + Str2int(ss));
   end;
   if not _IsNULL(Data) and not (Row < 0) then begin
      if Mode = ITM_ADD then
         Control.LVItemAdd('')
      else if (Mode = ITM_INSERT) and (Row < Control.Count) then
         Control.LVItemInsert(Row,'');     
      while not _IsNULL(Data) and (Row < Control.Count) do begin
         Control.LVSetItem(Row,Col,ReadString(Data,Null),iconum,[],I_SKIP,I_SKIP,DColor);
         inc(Col);
      end;
      _hi_CreateEvent_(Data,@_event_onChange);
   end;
end;

// MT-   
//
procedure ThiStringTableMT.MT_ActionCol; // 
var   s:string;
      ind:integer;
begin
   if _IsNULL(Data) then exit;

   ind:=ReadInteger(Data,Null); 
   s:=ReadString(Data,Null);   
   if (Mode = ITM_INSERT) and (ind >= 0) then begin
      if (ind > CList.Count - 1) then begin
         Control.LVColAdd('',FTextAlign,FColumnWidth);
         CList.Add(InitColStr(s));
      end
      else begin
         Control.LVColInsert(ind,'',FTextAlign,FColumnWidth);
         CList.Insert(ind,InitColStr(s));
      end;
   end
   else if (Mode = ITM_REPLACE) and not ((ind < 0)or(ind > CList.Count - 1)) then
      CList.Items[ind]:= InitColStr(s)
   else exit;
   SetColumns(CList,1);
   _hi_CreateEvent_(Data,@_event_onChangeColLst);
end;

// MT-    
//
procedure ThiStringTableMT.MT_ProperCol; // 
var   s,name,width,imgidx,aligntxt:string;
      ind:integer;
begin
   if _IsNULL(Data) then exit;

   ind:=ReadInteger(Data,Null);   
   s:=ReadString(Data,Null);   

   if (ind < 0) or (ind > CList.Count - 1) then exit;
   name:= Control.LVColText[ind];
   width:= int2str(Control.LVColWidth[ind]);
   imgidx:=int2str(Control.LVColImage[ind]);
   aligntxt:=int2str(integer(Control.LVColAlign[ind]));  
   if Mode = COL_NAME then name:= s
   else if Mode = COL_WIDTH then width:= s
   else if Mode = COL_IMAGE then imgidx:= s
   else if Mode = COL_ALIGN then aligntxt:= s
   else exit;   
   s:= name + '=' + width + '=' + imgidx + '=' + aligntxt;
   CList.Items[ind]:= InitColStr(s);
   SetColumns(CList,1);
   _hi_CreateEvent_(Data,@_event_onChangeColLst);   
end;

// MT-    
//
procedure ThiStringTableMT.MT_ActionIco; // 
var   idx:integer;
      di:TData;
begin
   if _IsNULL(Data) then exit;

   idx:= ReadInteger(Data,Null);
   di:= ReadData(Data,Null);
   if not _IsIcon(di) or not Assigned(Ilist) or (idx < 0) then exit;

   if (Mode = ITM_INSERT) and (idx > IList.Count - 1) then
      _AddIcon(di)
   else if (Mode = ITM_INSERT) and (idx < IList.Count) then 
      InsertIcon(di,idx)
   else if (Mode = ITM_REPLACE) and (idx < IList.Count) then
      IList.ReplaceIcon(idx, ToIcon(di).handle)
   else exit;
   SetColumns(CList,1);
   _hi_CreateEvent_(Data,@_event_onChangeImgLst);
end;

// MT-   
//
procedure ThiStringTableMT.MT_EMatrix; // 
var   x,y:integer;
      d:PData;
begin
   if _IsNULL(Data) then exit;
   
   FreeData(@FData_1);
   FreeData(@FData_2);
   dtNull(FData_1);   
   dtNull(FData_2);
   x:= ReadInteger(Data,Null);
   y:= ReadInteger(Data,Null);

   if (x >= 0) and (y >= 0) then begin
      if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
         ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
         (Mode = EMATRIX) then begin
            FData_2:= MX_Get(x,y);
            AddMTData(@FData_1,@FData_2,d); 
      end;
   end
   else if (x < 0) and (y >= 0) then begin
      for x:= 0 to Control.LVColCount - 1 do
         if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
            ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
            (Mode = EMATRIX) then begin              
               FData_2:= MX_Get(x,y);
               AddMTData(@FData_1,@FData_2,d); 
         end;
   end
   else if (x >= 0) and (y < 0) then begin
      for y:= 0 to Control.Count - 1 do
         if (((Control.LVItemStateImgIdx[y] - 1) > 0) and (Mode = CHK_EMATRIX))  or
            ((lvisSelect in Control.LVItemState[y])   and (Mode  = SEL_EMATRIX)) or
            (Mode = EMATRIX) then begin
                FData_2:= MX_Get(x,y);
               AddMTData(@FData_1,@FData_2,d); 
         end;
   end;
   _hi_onEvent_(_event_onMT_EMatrix,FData_1);
   if (d <> nil) and not _IsNULL(d^) then FreeData(d);
end;

//doMT_AddCols -    ,  MT-,
//                   - 
//               - (__ _  (0 - taLeft; 1 - taRight; 2 - taCenter))
//
procedure ThiStringTableMT._work_doMT_AddCols; // 
var   s:string;
begin
   if _IsNULL(_Data) then exit;

   if not FAllMT_AddCol then begin
      ReadString(_Data,Null);
      ReadString(_Data,Null);
   end;      
   while not _IsNULL(_Data) do begin
      s := ReadString(_Data,Null);
      Replace(s, _MTColDlm, '=');
      Control.LVColAdd('',FTextAlign,FColumnWidth);
      CList.Add(InitColStr(s));
   end; 
   SetColumns(CList,1);
   _hi_CreateEvent_(_Data,@_event_onChangeColLst);
end;

//doMT_CheckBox - / ,  MT-,
//                   - 
//                - (  (-1 - ))( (0 - ; 1 - ; 2 - ))
//
procedure ThiStringTableMT._work_doMT_CheckBox; // 
var   idx,val:integer;
begin
   if _IsNULL(_Data) then exit;

   idx := ReadInteger(_Data,Null);
   val := ReadInteger(_Data,Null);

   if (idx>=-1)and(idx<Control.Count) then Control.LVItemStateImgIdx[idx]:= val;
end;

//doMT_IconStr -        ,  MT-,
//                  - 
//               - ( )( )
//
procedure ThiStringTableMT._work_doMT_IconStr; // 
var   idx,newico:integer;
begin
   if _IsNULL(_Data) then exit;
   
   idx := ReadInteger(_Data,Null);
   newico := ReadInteger(_Data,Null);
   if Assigned(IList)and(idx>=0)and(idx<Control.Count)and(newico<IList.Count) then
      Control.LVItemImageIndex[idx]:= newico;
   Control.Invalidate;
end;

//doMT_IconCol -         ,  MT-,
//                  - 
//               - ( )( ).     
//
procedure ThiStringTableMT._work_doMT_IconCol; // 
var   idx,newico:integer;
      ta:TTextAlign;
begin
   if _IsNULL(_Data) then exit;
   
   idx := ReadInteger(_Data,Null);
   newico := ReadInteger(_Data,Null);
   ta:= Control.LVColAlign[idx];
   if Assigned(IList)and(idx>=0)and(idx<Control.Count)and(newico<IList.Count)and(FImgColumn) then
      Control.LVColImage[idx]:= newico;
   Control.LVColAlign[idx]:= ta;
   Control.Invalidate;
end;

//doMT_ColorsStr -       ,  MT-,
//                    - 
//                 - ( )(    ( 0 - TextColor))(  ( 0 - TextBkColor)).
//                        -1,    
//
procedure ThiStringTableMT._work_doMT_ColorsStr; // 
var   idx,idxcolortxt,colorback:integer;
begin
   if _IsNULL(_Data) then exit;

   idx := ReadInteger(_Data,Null);
   idxcolortxt := ReadInteger(_Data,Null);
   colorback := ReadInteger(_Data,Null);      

   if (idx < 0) or (idx > Control.Count - 1) or not FColorItems then exit; 
   if (idxcolortxt >= 0) and (idxcolortxt <= 15) then begin 
      Control.LVItemData[idx]:= $00FFFFFF and Control.LVItemData[idx];
      Control.LVItemData[idx]:= dword(idxcolortxt shl 24) or Control.LVItemData[idx];
   end;
   if colorback >= 0 then begin
      Control.LVItemData[idx]:= $0F000000 and Control.LVItemData[idx];
      Control.LVItemData[idx]:= Control.LVItemData[idx] or dword(colorback);
   end;
   Control.Invalidate; 
end;

//doGetColors_MT -             MT-  onMT_GetColors
//
procedure ThiStringTableMT._work_doGetColors_MT; // 
var   idx:integer;
      dt,di,dj,dk:TData;
      idxcolor:byte;
begin
   idx:= ToInteger(_Data);
   dtInteger(dt,idx);
   if (idx < 0) or (idx > Control.Count - 1) and FColorItems then exit; 
   idxcolor:= ($0F000000 and Control.LVItemData[idx]) shr 24;
   dtInteger(di,idxcolor);
   if idxcolor = 0 then
      dtInteger(dj,Color2RGB(FTextColor))  
   else
      dtInteger(dj,AColor[idxcolor]);
   if $FFFFFF and Control.LVItemData[idx] = 0 then
      dtInteger(dk,Color2RGB(FTextBkColor))
   else
      dtInteger(dk,$FFFFFF and Control.LVItemData[idx]);       
   dt.ldata:= @di;
   di.ldata:= @dj;
   dj.ldata:= @dk;
   _hi_onEvent_(_event_onMT_GetColors, dt);
end;

//doGetCol_MT -          MT-  onMT_GetCol
//
procedure ThiStringTableMT._work_doGetCol_MT; // 
var   idx:integer;
      dt,di,dj,dk,dl:TData;
begin
   idx:= ToInteger(_Data);
   if (idx < 0) or (idx > Control.LVColCount - 1) then exit;
   dtInteger(dt,idx);
   dtString(di,Control.LVColText[idx]);
   dtInteger(dj,Control.LVColWidth[idx]);
   dtInteger(dk,Control.LVColImage[idx]);
   dtInteger(dl,integer(Control.LVColAlign[idx]));
   dt.ldata:= @di;
   di.ldata:= @dj;
   dj.ldata:= @dk;
   dk.ldata:= @dl;
   _hi_onEvent_(_event_onMT_GetCol, dt);
end;

//-----------------   MT-     -------------------
//
//doMT_LoadExtIcon -       (*.exe,*.dll,*.ocx,*.icl),
//                      -
//                   - (  )(  )( )
//
procedure ThiStringTableMT._work_doMT_LoadExtIcon; // 
var   ico: PIcon;
      fn:string;
      dt,di:TData;
      idx:integer;
      bmp:PBitmap;
begin
   if _IsNULL(_Data) then exit;

   bmp :=nil;
   fn := ReadString(_Data,Null);
   idx := ReadInteger(_Data,Null);
   di := ReadData(_Data,Null);

   if not LFileExists_MT(fn,LOAD_EXTICON) then Exit;
   ico:= NewIcon;
   ico.LoadFromExecutable(fn,idx);
   if ico.Handle <> 0 then
      dtIcon(dt,ico)
   else if (_IsIcon(di)) and (ico.Handle = 0) then begin
      ico.free;
      ico:= NewIcon;
      dtData(dt,di);
      ico{$ifndef F_P}^{$endif} := ToIcon(dt){$ifndef F_P}^{$endif} ;
   end;
   if FIconToBmp then begin
      bmp:= NewDIBBitmap(Ico.Size,Ico.Size,pf32bit);
      bmp.Handle:= Ico.Convert2Bitmap(FTransparent);
      dtBitmap(dt,bmp);
   end;
   _hi_onEvent_(_event_onExtIcon, dt);
   If Assigned(bmp) then bmp.free;
   if Assigned(ico) then ico.free;
end;

//--------------------   MT-     ---------------------
//
//doMT_FindText -        (    ),
//                   -
//                - ( )( )( )(   ReplaceFind=True).
//                         
//
procedure ThiStringTableMT._work_doMT_FindText; // 
var str, strrepl, S2, S3:string;
    Row,Col,FPos:integer;
    dp,dt,ds:TData;
    d:PData;

    function Lower(Str:string): string;
    var i:integer;
    begin
       for i := 1 to Length(Str) do
       if (Str[i] in [ 'A'..'Z' ]) or (Str[i] in [ ''..'' ]) then
          Str[i] := chr(ord(Str[i]) or $20)
       else if Str[i] = '' then
          Str[i] := chr(ord(Str[i]) or $10);
       Result := Str;   
    end;

begin
   if _IsNULL(_Data) then exit;
    
   str := Lower(ReadString(_Data,Null));
   Row := ReadInteger(_Data,Null);
   Col := ReadInteger(_Data,Null); 

   if FFindReplace then
      strrepl := ReadString(_Data,Null)
   else 
      strrepl :='';
   FStrReplace := strrepl; 
   FStrFind := str;

   FreeData(@FData_1);
   FreeData(@FData_2);
   dtNull(FData_1);   
   dtNull(FData_2);
TRY
   if (Col = -1) or (Row = -1) or (str = '') then begin
      Row:= -1;
      Col:= -1;
      S3:= '';
      exit;
   end;   
   repeat
      repeat
         FPos := 1;
         S3:= Control.LVItems[Row,Col];
         S2:= Lower(S3);
         FPos := PosEx(str,S2,FPos);
         if FPos <> 0 then begin
            if FSelectFind then Control.LVCurItem:= Row;
            while FPos <> 0 do begin 
               if FFindReplace then begin
                  Delete(S3,FPos,Length(str));
                  if strrepl <> '' then Insert(strrepl,S3,FPos);
                  Control.LVItems[Row,Col] := S3;
                  S2 := Lower(S3); 
               end;
               if (not FFindReplace) or (FFindReplace and (strrepl <> '')) then begin
                  dtInteger(FData_2,FPos);            
                  AddMTData(@FData_1,@FData_2,d);
               end;
               if not FFindReplace then
                  inc(FPos,Length(str))
               else if FFindReplace and (strrepl <> '') then
                  inc(FPos,Length(strrepl));
               FPos := PosEx(str,S2,FPos);
            end;
            exit;
         end;
         inc(Col);
      until Col = Control.LVColCount;   
      inc(Row);
      Col:= 0;
   until Row = Control.Count;   
   Row:= -1;
   Col:= -1;
   S3:= '';
FINALLY
   dtInteger(dp,Row);
   dtInteger(dt,Col);
   FCol := Col;
   FRow := Row;
   dtString(ds,S3);
   dp.ldata:= @dt;
   dt.ldata:= @ds;
   ds.ldata:= @FData_1;
   _hi_onEvent_(_event_onMT_FindText,dp);
   if (d <> nil) and not _IsNULL(FData_2) then FreeData(d);
END;
end;

//-------------   MT-      --------------
//
//doMT_FindNext -      doMT_FindText
//                 ()   
//
procedure ThiStringTableMT._work_doMT_FindNext; // 
var   dp,dt,ds:TData;

begin
   dtNull(_Data);
   if (FRow <> -1) or (FCol <> -1) then begin
      inc(FCol);
      if FCol = CList.Count then begin
         FCol := 0;
         inc(FRow);
         if FRow = Control.Count then begin
            FRow := -1;
            FCol := -1;
            FStrFind := '';
         end;
      end;
   end;
   dtString(_Data,FStrFind);
   dtInteger(dt,FRow);
   dtInteger(ds,FCol);
   _Data.ldata:= @dt;
   dt.ldata:= @ds;
   if FFindReplace then begin
      dtString(dp,FStrReplace);
      ds.ldata:= @dp;      
   end;
   _work_doMT_FindText(_Data,0);
end;
//-----------------        -----------------
//
//doAutoColWidth -        
//                 (   -1)    
//
procedure ThiStringTableMT._work_doAutoColWidth; // 
var   FCol,Col,Row:integer;
      _Length, TempLength:integer;
      dt,di:TData;
begin
   FCol := ToInteger(_Data);
   if (Control.LVColCount <= 0) or (Control.Count <= 0) or (FCol > Control.LVColCount - 1) then exit;
   if FCol < 0 then begin
      FCol := Control.LVColCount;
      Col:= 0;
   end else begin
      Col := FCol;
      inc(FCol);
   end;
   repeat
      Row:= 0;
      _Length:= 0;
      repeat
         TempLength:= (Control.Canvas.TextWidth(Control.LVItems[Row,Col])) + 2*Control.Canvas.TextExtent('M').cx;
         if Col = 0 then begin
            if FCheckBoxes then TempLength:= TempLength + FImgSize;
            if Assigned(IList) then TempLength:= TempLength + FImgSize;              
         end;
         _Length:= max(_Length,TempLength);
         inc(Row);                                                     
      until Row = Control.Count;
      _Length:= min(_Length,FMaxColWidth);
      _Length:= max(_Length,FMinColWidth);      
      dtInteger(dt,Col);
      dtInteger(di,_Length);
      dt.ldata:= @di;
      MT_ProperCol(dt, COL_WIDTH);
      inc(Col);
   until Col = FCol;
end;

//-----------------------   MT-   ---------------------------
//
//GenColors_MT -  MT-   ,
//                  -
//               - (BkColor)(TextColor)(TextBkColor)(TranspColor)
//
procedure ThiStringTableMT._var_GenColors_MT; // 
var   da,db,dc,dd:TData;
begin
   FreeData(@FData);
   dtNull(FData);
   dtInteger(da,Color2RGB(FBkColor));
   dtInteger(db,Color2RGB(FTextColor));
   dtInteger(dc,Color2RGB(FTextBkColor));
   dtInteger(dd,Color2RGB(FTransparent));
   da.ldata := @db;
   db.ldata := @dc;
   dc.ldata := @dd;
   CopyData(@FData,@da);
   _Data := FData;
end;
//
//AllSelect_MT -  MT-   
//
procedure ThiStringTableMT._var_AllSelect_MT; // 
var   i,j:integer;
      d:PData;
begin
   FreeData(@FData);
   FreeData(@FData_2);
   dtNull(FData);
   dtNull(FData_2);
   i:= Control.LVCurItem;
   if Control.LVSelCount > 0 then begin
      repeat
         dtInteger(FData_2,i);
         AddMTData(@FData,@FData_2,d); 
         j:= Control.LVNextSelected(i);
         i:= j;
      until j < 0;
   end;
   _Data := FData;
end;
//
//AllCheck_MT -  MT-     
//
procedure ThiStringTableMT._var_AllCheck_MT; // 
var   i,j: word;
      d:PData;
begin
   FreeData(@FData);
   FreeData(@FData_2);
   dtNull(FData);
   dtNull(FData_2);
   if Control.Count > 0 then begin
      for i:=0 to Control.Count - 1 do begin
         j:= Control.LVItemStateImgIdx[i];
         if j > 1 then 
            dtInteger(FData_2,i)
         else
            dtNull(FData_2); 
         AddMTData(@FData,@FData_2,d);
      end;
   end;
   _Data := FData;
end;
//
//----------------------------      ------------------------------
end.